########### Generate files for Figures ###########################################

extractfile:
	make Data/dmDei5iter1Mask.H
	make Data/dmDei5NSafter.H
	make Data/dmDei5NSafter2.H
	make Input/velDeimos3D.H
	make Data/rtmDeiGTotal.H
	make Data/mDeiHbInterpiter2.H
	make Data/mDeiIInterpiter2.H
	make Data/mDeiJInterpiter2.H
	make Data/mDeiIInterpiter26.H
	make Data/mDeiJInterpiter26.H

########### files make rules ###########################################


Data/dmDei5iter1Mask.H: Bin/offsetmask.x 
	python ~/Setup/pyRemove.py tmp1shot$*.H
	Window3d < LSM/Hb/dm/dmDeiHb5iter1.H n3=1 f3=14 > tmp1shot$*.H
	echo "n3=1 o3=3480. d3=25. label3=y n4=61 o4=-750 d4=25." >> tmp1shot$*.H
	Bin/offsetmask.x < tmp1shot$*.H vel=6. zmute=100. outfile1=$@ >/dev/null
	echo "label1=z label2=x label4=hx" >> $@
	python ~/Setup/pyRemove.py tmp1shot$*.H

Gx=57350.

Data/dmDei5NSafter.H Data/dmDei5NSafter2.H: Bin/Testkzkh.x Data/dmDei5iter1Mask.H
	python pycode/pyRemove.py Data/dmDei5NSafter.H Data/dmDei5NSafter2.H Data/dmDei5iter1kzkh1.H Data/dmDei5iter1kzkh2.H 
	Bin/Testkzkh.x < Data/dmDei5iter1Mask.H outtag=Data/dmDei5NSafter.H elseouttag=Data/dmDei5NSafter2.H kzkhfile=Data/dmDei5iter1kzkh1.H kzkhfile2=Data/dmDei5iter1kzkh2.H zhout=1 kzkhout=1 Gx=${Gx} shotnum=5 >/dev/null UD=1


Input/velDeimos3D.H:	
	test -d Input/velDeimos3D.H || cp ${deidir}/Input/velDeimos3D.H Input/.

Data/rtmDeiGTotal.H:
	test -d $@ || cp rtm/G/rtmDeiGTotal.H $@


Data/mDeiHbInterpiter%.H:
	rm -f cmdfile$*.txt
	echo "Bin/offsetmask.x < LSM/Hb/m/mDeiHbTotaliter$*.H vel=6. zmute=100. outfile1=LSM/Hb/m/mtmpiter$*.H >/dev/null" >> cmdfile$*.txt
	echo "${SEPBIN}/Interp < LSM/Hb/m/mtmpiter$*.H d1out=12.5 > $@" >> cmdfile$*.txt
	echo "pycode/pyRemove.py LSM/Hb/m/mtmpiter$*.H" >> cmdfile$*.txt
	pycode/pyWritePBS.py 1 8 '24:00:00' '2gb' interp$* cmdfile$*.txt


Data/mDeiIInterpiter%.H:
	rm -f cmdfile$*.txt
	echo "Bin/offsetmask.x < LSM/I/m/mDeiITotaliter$*.H vel=6. zmute=100. outfile1=LSM/I/m/mtmpiter$*.H >/dev/null" >> cmdfile$*.txt
	echo "${SEPBIN}/Interp < LSM/I/m/mtmpiter$*.H d1out=12.5 > $@" >> cmdfile$*.txt
	echo "pycode/pyRemove.py LSM/I/m/mtmpiter$*.H" >> cmdfile$*.txt
	pycode/pyWritePBS.py 1 8 '24:00:00' '2gb' interp$* cmdfile$*.txt


Data/mDeiJInterpiter%.H:
	rm -f cmdfile$*.txt
	echo "Bin/offsetmask.x < LSM/Joint/m/mDeiJointTotaliter$*.H vel=6. zmute=100. outfile1=LSM/Joint/m/mtmpiter$*.H >/dev/null" >> cmdfile$*.txt
	echo "${SEPBIN}/Interp < LSM/Joint/m/mtmpiter$*.H d1out=12.5 > $@" >> cmdfile$*.txt
	echo "pycode/pyRemove.py LSM/Joint/m/mtmpiter$*.H" >> cmdfile$*.txt
	pycode/pyWritePBS.py 1 8 '24:00:00' '2gb' interp$* cmdfile$*.txt


