program DSO3d
! Apply DSO operation on 3d file (along hx axis only)
! Input:  model(z,x,y,hx)
! Output:  eps*abs(hx)*model(z,x,y,hx)

  use sep
  use waveprop3d_mod
  use type3d_mod
  use smooth3d_mod

  logical                    :: adj
  integer                   :: n1,n2,n3,n4
  integer                   :: i
  real                      :: eps
  real                      :: o1, o2, o3, o4
  real                      :: d1, d2, d3, d4
  real, dimension(:,:,:,:), allocatable :: inArray, outArray
  character(len=128)        :: label1, label2, label3, label4
  character(len=128)        :: infile_, outfile_


  call sep_init()

  call from_param("adj", adj);
  call from_param("eps",eps,1.0);

  call from_param('outfile',outfile_) 
  call from_param('infile',infile_) 


  n1=1.; n2=1.; n3=1.;  n4=1.; n5=1.;

     call from_aux(infile_, "n1", n1);    call from_aux(infile_,"d1",d1);     call from_aux(infile_, "o1",o1);
     call from_aux(infile_, "label1",label1);
     call from_aux(infile_, "n2", n2);    call from_aux(infile_,"d2",d2);     call from_aux(infile_, "o2",o2);
     call from_aux(infile_, "label2",label2);
     call from_aux(infile_, "n3", n3);    call from_aux(infile_,"d3",d3,1.);     call from_aux(infile_, "o3",o3,0.);
     call from_aux(infile_, "label3",label3);
     call from_aux(infile_, "n4", n4);    call from_aux(infile_,"d4",d4);     call from_aux(infile_, "o4",o4);
     call from_aux(infile_, "label4",label4);



  allocate(inArray(n1,n2,n3,n4), outArray(n1,n2,n3,n4))
  do i4=1,n4
    do i3=1,n3
    do i2=1,n2
    do i1=1,n1
      inArray(i1,i2,i3,i4) = 0.
      outArray(i1,i2,i3,i4) = 0.
    end do
    end do
    end do
  end do

  call sep_read(inArray, infile_);
  
  do i4=1,n4
       hx = o4+d4*(i4-1)
    do i3=1,n3
    do i2=1,n2
    do i1=1,n1
      outArray(i1,i2,i3,i4) = eps*inArray(i1,i2,i3,i4)*abs(hx)
    end do
    end do
    end do
  end do


         call auxputch("n1",'i',n1, trim(outfile_));     
         call auxputch("d1",'f',d1, trim(outfile_));   
         call auxputch("o1",'f',o1,trim(outfile_));
         call auxputch("label1",'s',label1,trim(outfile_));
	  call auxputch("n2",'i',n2, trim(outfile_));     
	  call auxputch("d2",'f',d2, trim(outfile_));   
	  call auxputch("o2",'f',o2,trim(outfile_));
          call auxputch("label2",'s',label2,trim(outfile_));
	  call auxputch("n3",'i',n3, trim(outfile_));     
	  call auxputch("d3",'f',d3, trim(outfile_));   
	  call auxputch("o3",'f',o3,trim(outfile_));
          call auxputch("label3",'s',label3,trim(outfile_));
	  call auxputch("n4",'i',n4, trim(outfile_));     
	  call auxputch("d4",'f',d4, trim(outfile_));   
	  call auxputch("o4",'f',o4,trim(outfile_));
          call auxputch("label4",'s',label4,trim(outfile_));

     call sep_write(outArray, outfile_);


end program
