module kzkh_mod

  use sep
  use smooth3d_mod

  implicit none
  real :: ppi=4.*atan(1.)
  real   :: dipAng(16,10,5)
  ! dim1 = shot number
  ! dim2 = partition of diffX
  ! dim3 1=distant, 2=positive-angle, 3=positive angle-range
  ! dim3 4=negative angle, 5=negative angle range


contains
!============================================================================

subroutine initiateDipAng_Up()

  !! shot 1 Up
  dipAng(1,1,1) =0.;    dipAng(1,1,2) =0.;   dipAng(1,1,3) =12;  dipAng(1,1,4) =0.;   dipAng(1,1,5) =12;       ! 0m
  dipAng(1,2,1) =250.;  dipAng(1,2,2) =10.;   dipAng(1,2,3) =12;  dipAng(1,2,4) =0.;   dipAng(1,2,5) =12;      ! 250m
  dipAng(1,3,1) =500.;  dipAng(1,3,2) =15.;   dipAng(1,3,3) =12;  dipAng(1,3,4) =0.;   dipAng(1,3,5) =12;      ! 500m
  dipAng(1,4,1) =750.;  dipAng(1,4,2) =20.;   dipAng(1,4,3) =12;  dipAng(1,4,4) =0.;   dipAng(1,4,5) =12;      ! 750m
  dipAng(1,5,1) =1000.; dipAng(1,5,2) =20.;  dipAng(1,5,3) =12;  dipAng(1,5,4) =0.;   dipAng(1,5,5) =12;      ! 1000m
  dipAng(1,6,1) =1250.; dipAng(1,6,2) =25.;  dipAng(1,6,3) =12;  dipAng(1,6,4) =0.;   dipAng(1,6,5) =12;      ! 1250m
  dipAng(1,7,1) =1500.; dipAng(1,7,2) =30.;  dipAng(1,7,3) =12;  dipAng(1,7,4) =10.;  dipAng(1,7,5) =12;      ! 1500m
  dipAng(1,8,1) =1750.; dipAng(1,8,2) =35.;  dipAng(1,8,3) =12;  dipAng(1,8,4) =20.;  dipAng(1,8,5) =12;      ! 1750m
  dipAng(1,9,1) =2000.; dipAng(1,9,2) =35.;  dipAng(1,9,3) =12;  dipAng(1,9,4) =30.;  dipAng(1,9,5) =12;      ! 2000m
  dipAng(1,10,1)=2250.; dipAng(1,10,2) =35.; dipAng(1,10,3) =12; dipAng(1,10,4) =40.; dipAng(1,10,5) =12;     ! 2250m

  !! shot 2 Up
  dipAng(2,1,1) =0.;    dipAng(2,1,2) =0.;   dipAng(2,1,3) =15;  dipAng(2,1,4) =0.;   dipAng(2,1,5) =12;       ! 0m
  dipAng(2,2,1) =250.;  dipAng(2,2,2) =13.;   dipAng(2,2,3) =15;  dipAng(2,2,4) =10.;   dipAng(2,2,5) =12;      ! 250m
  dipAng(2,3,1) =500.;  dipAng(2,3,2) =20.;   dipAng(2,3,3) =15;  dipAng(2,3,4) =15.;   dipAng(2,3,5) =12;      ! 500m
  dipAng(2,4,1) =750.;  dipAng(2,4,2) =23.;   dipAng(2,4,3) =15;  dipAng(2,4,4) =20.;   dipAng(2,4,5) =12;      ! 750m
  dipAng(2,5,1) =1000.; dipAng(2,5,2) =23.;  dipAng(2,5,3) =15;  dipAng(2,5,4) =20.;   dipAng(2,5,5) =12;      ! 1000m
  dipAng(2,6,1) =1250.; dipAng(2,6,2) =25.;  dipAng(2,6,3) =15;  dipAng(2,6,4) =25.;   dipAng(2,6,5) =12;      ! 1250m
  dipAng(2,7,1) =1500.; dipAng(2,7,2) =28.;  dipAng(2,7,3) =15;  dipAng(2,7,4) =30.;  dipAng(2,7,5) =12;      ! 1500m
  dipAng(2,8,1) =1750.; dipAng(2,8,2) =30.;  dipAng(2,8,3) =15;  dipAng(2,8,4) =35.;  dipAng(2,8,5) =12;      ! 1750m
  dipAng(2,9,1) =2000.; dipAng(2,9,2) =33.;  dipAng(2,9,3) =15;  dipAng(2,9,4) =35.;  dipAng(2,9,5) =12;      ! 2000m
  dipAng(2,10,1)=2250.; dipAng(2,10,2) =38.; dipAng(2,10,3) =15; dipAng(2,10,4) =40.; dipAng(2,10,5) =12;     ! 2250m

  !! shot 3 Up
  dipAng(3,1,1) =0.;    dipAng(3,1,2) =0.;   dipAng(3,1,3) =15;  dipAng(3,1,4) =0.;   dipAng(3,1,5) =12;       ! 0m
  dipAng(3,2,1) =250.;  dipAng(3,2,2) =13.;   dipAng(3,2,3) =15;  dipAng(3,2,4) =10.;   dipAng(3,2,5) =12;      ! 250m
  dipAng(3,3,1) =500.;  dipAng(3,3,2) =18.;   dipAng(3,3,3) =15;  dipAng(3,3,4) =15.;   dipAng(3,3,5) =12;      ! 500m
  dipAng(3,4,1) =750.;  dipAng(3,4,2) =18.;   dipAng(3,4,3) =15;  dipAng(3,4,4) =20.;   dipAng(3,4,5) =12;      ! 750m
  dipAng(3,5,1) =1000.; dipAng(3,5,2) =23.;  dipAng(3,5,3) =15;  dipAng(3,5,4) =20.;   dipAng(3,5,5) =12;      ! 1000m
  dipAng(3,6,1) =1250.; dipAng(3,6,2) =25.;  dipAng(3,6,3) =15;  dipAng(3,6,4) =25.;   dipAng(3,6,5) =12;      ! 1250m
  dipAng(3,7,1) =1500.; dipAng(3,7,2) =28.;  dipAng(3,7,3) =15;  dipAng(3,7,4) =30.;  dipAng(3,7,5) =12;      ! 1500m
  dipAng(3,8,1) =1750.; dipAng(3,8,2) =30.;  dipAng(3,8,3) =15;  dipAng(3,8,4) =35.;  dipAng(3,8,5) =12;      ! 1750m
  dipAng(3,9,1) =2000.; dipAng(3,9,2) =33.;  dipAng(3,9,3) =15;  dipAng(3,9,4) =35.;  dipAng(3,9,5) =12;      ! 2000m
  dipAng(3,10,1)=2250.; dipAng(3,10,2) =38.; dipAng(3,10,3) =15; dipAng(3,10,4) =40.; dipAng(3,10,5) =12;     ! 2250m

  !! shot 4 Up
  dipAng(4,1,1) =0.;    dipAng(4,1,2) =0.;   dipAng(4,1,3) =15;  dipAng(4,1,4) =0.;   dipAng(4,1,5) =12;       ! 0m
  dipAng(4,2,1) =250.;  dipAng(4,2,2) =13.;   dipAng(4,2,3) =15;  dipAng(4,2,4) =10.;   dipAng(4,2,5) =12;      ! 250m
  dipAng(4,3,1) =500.;  dipAng(4,3,2) =18.;   dipAng(4,3,3) =15;  dipAng(4,3,4) =15.;   dipAng(4,3,5) =12;      ! 500m
  dipAng(4,4,1) =750.;  dipAng(4,4,2) =18.;   dipAng(4,4,3) =15;  dipAng(4,4,4) =20.;   dipAng(4,4,5) =12;      ! 750m
  dipAng(4,5,1) =1000.; dipAng(4,5,2) =23.;  dipAng(4,5,3) =15;  dipAng(4,5,4) =20.;   dipAng(4,5,5) =12;      ! 1000m
  dipAng(4,6,1) =1250.; dipAng(4,6,2) =25.;  dipAng(4,6,3) =15;  dipAng(4,6,4) =25.;   dipAng(4,6,5) =12;      ! 1250m
  dipAng(4,7,1) =1500.; dipAng(4,7,2) =28.;  dipAng(4,7,3) =15;  dipAng(4,7,4) =30.;  dipAng(4,7,5) =12;      ! 1500m
  dipAng(4,8,1) =1750.; dipAng(4,8,2) =30.;  dipAng(4,8,3) =15;  dipAng(4,8,4) =35.;  dipAng(4,8,5) =12;      ! 1750m
  dipAng(4,9,1) =2000.; dipAng(4,9,2) =33.;  dipAng(4,9,3) =15;  dipAng(4,9,4) =35.;  dipAng(4,9,5) =12;      ! 2000m
  dipAng(4,10,1)=2250.; dipAng(4,10,2) =38.; dipAng(4,10,3) =15; dipAng(4,10,4) =40.; dipAng(4,10,5) =12;     ! 2250m

  !! shot 5 Up
  dipAng(5,1,1) =0.;    dipAng(5,1,2) =0.;   dipAng(5,1,3) =15;  dipAng(5,1,4) =0.;   dipAng(5,1,5) =12;       ! 0m
  dipAng(5,2,1) =250.;  dipAng(5,2,2) =13.;   dipAng(5,2,3) =15;  dipAng(5,2,4) =10.;   dipAng(5,2,5) =12;      ! 250m
  dipAng(5,3,1) =500.;  dipAng(5,3,2) =18.;   dipAng(5,3,3) =15;  dipAng(5,3,4) =15.;   dipAng(5,3,5) =12;      ! 500m
  dipAng(5,4,1) =750.;  dipAng(5,4,2) =18.;   dipAng(5,4,3) =15;  dipAng(5,4,4) =20.;   dipAng(5,4,5) =12;      ! 750m
  dipAng(5,5,1) =1000.; dipAng(5,5,2) =23.;  dipAng(5,5,3) =15;  dipAng(5,5,4) =20.;   dipAng(5,5,5) =12;      ! 1000m
  dipAng(5,6,1) =1250.; dipAng(5,6,2) =25.;  dipAng(5,6,3) =15;  dipAng(5,6,4) =25.;   dipAng(5,6,5) =12;      ! 1250m
  dipAng(5,7,1) =1500.; dipAng(5,7,2) =28.;  dipAng(5,7,3) =15;  dipAng(5,7,4) =30.;  dipAng(5,7,5) =12;      ! 1500m
  dipAng(5,8,1) =1750.; dipAng(5,8,2) =30.;  dipAng(5,8,3) =15;  dipAng(5,8,4) =35.;  dipAng(5,8,5) =12;      ! 1750m
  dipAng(5,9,1) =2000.; dipAng(5,9,2) =33.;  dipAng(5,9,3) =15;  dipAng(5,9,4) =35.;  dipAng(5,9,5) =12;      ! 2000m
  dipAng(5,10,1)=2250.; dipAng(5,10,2) =38.; dipAng(5,10,3) =15; dipAng(5,10,4) =40.; dipAng(5,10,5) =12;     ! 2250m

  !! shot 6 Up
  dipAng(6,1,1) =0.;    dipAng(6,1,2) =0.;   dipAng(6,1,3) =15;  dipAng(6,1,4) =0.;   dipAng(6,1,5) =15;       ! 0m
  dipAng(6,2,1) =250.;  dipAng(6,2,2) =10.;   dipAng(6,2,3) =15;  dipAng(6,2,4) =10.;   dipAng(6,2,5) =15;      ! 250m
  dipAng(6,3,1) =500.;  dipAng(6,3,2) =15.;   dipAng(6,3,3) =15;  dipAng(6,3,4) =15.;   dipAng(6,3,5) =15;      ! 500m
  dipAng(6,4,1) =750.;  dipAng(6,4,2) =20.;   dipAng(6,4,3) =15;  dipAng(6,4,4) =20.;   dipAng(6,4,5) =15;      ! 750m
  dipAng(6,5,1) =1000.; dipAng(6,5,2) =20.;  dipAng(6,5,3) =15;  dipAng(6,5,4) =20.;   dipAng(6,5,5) =15;      ! 1000m
  dipAng(6,6,1) =1250.; dipAng(6,6,2) =25.;  dipAng(6,6,3) =15;  dipAng(6,6,4) =25.;   dipAng(6,6,5) =15;      ! 1250m
  dipAng(6,7,1) =1500.; dipAng(6,7,2) =30.;  dipAng(6,7,3) =15;  dipAng(6,7,4) =30.;  dipAng(6,7,5) =15;      ! 1500m
  dipAng(6,8,1) =1750.; dipAng(6,8,2) =35.;  dipAng(6,8,3) =15;  dipAng(6,8,4) =35.;  dipAng(6,8,5) =15;      ! 1750m
  dipAng(6,9,1) =2000.; dipAng(6,9,2) =35.;  dipAng(6,9,3) =15;  dipAng(6,9,4) =35.;  dipAng(6,9,5) =15;      ! 2000m
  dipAng(6,10,1)=2250.; dipAng(6,10,2) =40.; dipAng(6,10,3) =15; dipAng(6,10,4) =40.; dipAng(6,10,5) =15;     ! 2250m

  !! shot 7 Up
  dipAng(7,1,1) =0.;    dipAng(7,1,2) =0.;   dipAng(7,1,3) =15;  dipAng(7,1,4) =0.;   dipAng(7,1,5) =15;       ! 0m
  dipAng(7,2,1) =250.;  dipAng(7,2,2) =10.;   dipAng(7,2,3) =15;  dipAng(7,2,4) =10.;   dipAng(7,2,5) =15;      ! 250m
  dipAng(7,3,1) =500.;  dipAng(7,3,2) =15.;   dipAng(7,3,3) =15;  dipAng(7,3,4) =15.;   dipAng(7,3,5) =15;      ! 500m
  dipAng(7,4,1) =750.;  dipAng(7,4,2) =20.;   dipAng(7,4,3) =15;  dipAng(7,4,4) =20.;   dipAng(7,4,5) =15;      ! 750m
  dipAng(7,5,1) =1000.; dipAng(7,5,2) =20.;  dipAng(7,5,3) =15;  dipAng(7,5,4) =20.;   dipAng(7,5,5) =15;      ! 1000m
  dipAng(7,6,1) =1250.; dipAng(7,6,2) =25.;  dipAng(7,6,3) =15;  dipAng(7,6,4) =25.;   dipAng(7,6,5) =15;      ! 1250m
  dipAng(7,7,1) =1500.; dipAng(7,7,2) =30.;  dipAng(7,7,3) =15;  dipAng(7,7,4) =30.;  dipAng(7,7,5) =15;      ! 1500m
  dipAng(7,8,1) =1750.; dipAng(7,8,2) =35.;  dipAng(7,8,3) =15;  dipAng(7,8,4) =35.;  dipAng(7,8,5) =15;      ! 1750m
  dipAng(7,9,1) =2000.; dipAng(7,9,2) =35.;  dipAng(7,9,3) =15;  dipAng(7,9,4) =35.;  dipAng(7,9,5) =15;      ! 2000m
  dipAng(7,10,1)=2250.; dipAng(7,10,2) =40.; dipAng(7,10,3) =15; dipAng(7,10,4) =40.; dipAng(7,10,5) =15;     ! 2250m

  !! shot 8 Up
  dipAng(8,1,1) =0.;    dipAng(8,1,2) =0.;   dipAng(8,1,3) =15;  dipAng(8,1,4) =0.;   dipAng(8,1,5) =15;       ! 0m
  dipAng(8,2,1) =250.;  dipAng(8,2,2) =10.;   dipAng(8,2,3) =15;  dipAng(8,2,4) =10.;   dipAng(8,2,5) =15;      ! 250m
  dipAng(8,3,1) =500.;  dipAng(8,3,2) =15.;   dipAng(8,3,3) =15;  dipAng(8,3,4) =15.;   dipAng(8,3,5) =15;      ! 500m
  dipAng(8,4,1) =750.;  dipAng(8,4,2) =20.;   dipAng(8,4,3) =15;  dipAng(8,4,4) =20.;   dipAng(8,4,5) =15;      ! 750m
  dipAng(8,5,1) =1000.; dipAng(8,5,2) =20.;  dipAng(8,5,3) =15;  dipAng(8,5,4) =20.;   dipAng(8,5,5) =15;      ! 1000m
  dipAng(8,6,1) =1250.; dipAng(8,6,2) =25.;  dipAng(8,6,3) =15;  dipAng(8,6,4) =25.;   dipAng(8,6,5) =15;      ! 1250m
  dipAng(8,7,1) =1500.; dipAng(8,7,2) =30.;  dipAng(8,7,3) =15;  dipAng(8,7,4) =30.;  dipAng(8,7,5) =15;      ! 1500m
  dipAng(8,8,1) =1750.; dipAng(8,8,2) =35.;  dipAng(8,8,3) =15;  dipAng(8,8,4) =35.;  dipAng(8,8,5) =15;      ! 1750m
  dipAng(8,9,1) =2000.; dipAng(8,9,2) =35.;  dipAng(8,9,3) =15;  dipAng(8,9,4) =35.;  dipAng(8,9,5) =15;      ! 2000m
  dipAng(8,10,1)=2250.; dipAng(8,10,2) =40.; dipAng(8,10,3) =15; dipAng(8,10,4) =40.; dipAng(8,10,5) =15;     ! 2250m

  !! shot 9 Up
  dipAng(9,1,1) =0.;    dipAng(9,1,2) =0.;   dipAng(9,1,3) =15;  dipAng(9,1,4) =0.;   dipAng(9,1,5) =15;       ! 0m
  dipAng(9,2,1) =250.;  dipAng(9,2,2) =10.;   dipAng(9,2,3) =15;  dipAng(9,2,4) =10.;   dipAng(9,2,5) =15;      ! 250m
  dipAng(9,3,1) =500.;  dipAng(9,3,2) =15.;   dipAng(9,3,3) =15;  dipAng(9,3,4) =15.;   dipAng(9,3,5) =15;      ! 500m
  dipAng(9,4,1) =750.;  dipAng(9,4,2) =20.;   dipAng(9,4,3) =15;  dipAng(9,4,4) =20.;   dipAng(9,4,5) =15;      ! 750m
  dipAng(9,5,1) =1000.; dipAng(9,5,2) =20.;  dipAng(9,5,3) =15;  dipAng(9,5,4) =20.;   dipAng(9,5,5) =15;      ! 1000m
  dipAng(9,6,1) =1250.; dipAng(9,6,2) =25.;  dipAng(9,6,3) =15;  dipAng(9,6,4) =25.;   dipAng(9,6,5) =15;      ! 1250m
  dipAng(9,7,1) =1500.; dipAng(9,7,2) =30.;  dipAng(9,7,3) =15;  dipAng(9,7,4) =30.;  dipAng(9,7,5) =15;      ! 1500m
  dipAng(9,8,1) =1750.; dipAng(9,8,2) =35.;  dipAng(9,8,3) =15;  dipAng(9,8,4) =35.;  dipAng(9,8,5) =15;      ! 1750m
  dipAng(9,9,1) =2000.; dipAng(9,9,2) =35.;  dipAng(9,9,3) =15;  dipAng(9,9,4) =35.;  dipAng(9,9,5) =15;      ! 2000m
  dipAng(9,10,1)=2250.; dipAng(9,10,2) =40.; dipAng(9,10,3) =15; dipAng(9,10,4) =40.; dipAng(9,10,5) =15;     ! 2250m

  !! shot 10 Up
  dipAng(10,1,1) =0.;    dipAng(10,1,2) =0.;   dipAng(10,1,3) =15;  dipAng(10,1,4) =0.;   dipAng(10,1,5) =15;       ! 0m
  dipAng(10,2,1) =250.;  dipAng(10,2,2) =10.;   dipAng(10,2,3) =15;  dipAng(10,2,4) =10.;   dipAng(10,2,5) =15;      ! 250m
  dipAng(10,3,1) =500.;  dipAng(10,3,2) =15.;   dipAng(10,3,3) =15;  dipAng(10,3,4) =15.;   dipAng(10,3,5) =15;      ! 500m
  dipAng(10,4,1) =750.;  dipAng(10,4,2) =20.;   dipAng(10,4,3) =15;  dipAng(10,4,4) =20.;   dipAng(10,4,5) =15;      ! 750m
  dipAng(10,5,1) =1000.; dipAng(10,5,2) =20.;  dipAng(10,5,3) =15;  dipAng(10,5,4) =20.;   dipAng(10,5,5) =15;      ! 1000m
  dipAng(10,6,1) =1250.; dipAng(10,6,2) =25.;  dipAng(10,6,3) =15;  dipAng(10,6,4) =25.;   dipAng(10,6,5) =15;      ! 1250m
  dipAng(10,7,1) =1500.; dipAng(10,7,2) =30.;  dipAng(10,7,3) =15;  dipAng(10,7,4) =30.;  dipAng(10,7,5) =15;      ! 1500m
  dipAng(10,8,1) =1750.; dipAng(10,8,2) =35.;  dipAng(10,8,3) =15;  dipAng(10,8,4) =35.;  dipAng(10,8,5) =15;      ! 1750m
  dipAng(10,9,1) =2000.; dipAng(10,9,2) =35.;  dipAng(10,9,3) =15;  dipAng(10,9,4) =35.;  dipAng(10,9,5) =15;      ! 2000m
  dipAng(10,10,1)=2250.; dipAng(10,10,2) =40.; dipAng(10,10,3) =15; dipAng(10,10,4) =40.; dipAng(10,10,5) =15;     ! 2250m

  !! shot 11 Up
  dipAng(11,1,1) =0.;    dipAng(11,1,2) =0.;   dipAng(11,1,3) =15;  dipAng(11,1,4) =0.;   dipAng(11,1,5) =12;       ! 0m
  dipAng(11,2,1) =250.;  dipAng(11,2,2) =10.;   dipAng(11,2,3) =15;  dipAng(11,2,4) =10.;   dipAng(11,2,5) =12;      ! 250m
  dipAng(11,3,1) =500.;  dipAng(11,3,2) =15.;   dipAng(11,3,3) =15;  dipAng(11,3,4) =15.;   dipAng(11,3,5) =12;      ! 500m
  dipAng(11,4,1) =750.;  dipAng(11,4,2) =20.;   dipAng(11,4,3) =15;  dipAng(11,4,4) =20.;   dipAng(11,4,5) =12;      ! 750m
  dipAng(11,5,1) =1000.; dipAng(11,5,2) =20.;  dipAng(11,5,3) =15;  dipAng(11,5,4) =20.;   dipAng(11,5,5) =12;      ! 1000m
  dipAng(11,6,1) =1250.; dipAng(11,6,2) =25.;  dipAng(11,6,3) =15;  dipAng(11,6,4) =25.;   dipAng(11,6,5) =12;      ! 1250m
  dipAng(11,7,1) =1500.; dipAng(11,7,2) =30.;  dipAng(11,7,3) =15;  dipAng(11,7,4) =30.;  dipAng(11,7,5) =12;      ! 1500m
  dipAng(11,8,1) =1750.; dipAng(11,8,2) =35.;  dipAng(11,8,3) =15;  dipAng(11,8,4) =35.;  dipAng(11,8,5) =12;      ! 1750m
  dipAng(11,9,1) =2000.; dipAng(11,9,2) =35.;  dipAng(11,9,3) =15;  dipAng(11,9,4) =35.;  dipAng(11,9,5) =12;      ! 2000m
  dipAng(11,10,1)=2250.; dipAng(11,10,2) =40.; dipAng(11,10,3) =15; dipAng(11,10,4) =40.; dipAng(11,10,5) =12;     ! 2250m

  !! shot 12 Up
  dipAng(12,1,1) =0.;    dipAng(12,1,2) =0.;   dipAng(12,1,3) =15;  dipAng(12,1,4) =0.;   dipAng(12,1,5) =12;       ! 0m
  dipAng(12,2,1) =250.;  dipAng(12,2,2) =13.;   dipAng(12,2,3) =15;  dipAng(12,2,4) =10.;   dipAng(12,2,5) =12;      ! 250m
  dipAng(12,3,1) =500.;  dipAng(12,3,2) =18.;   dipAng(12,3,3) =15;  dipAng(12,3,4) =15.;   dipAng(12,3,5) =12;      ! 500m
  dipAng(12,4,1) =750.;  dipAng(12,4,2) =18.;   dipAng(12,4,3) =15;  dipAng(12,4,4) =20.;   dipAng(12,4,5) =12;      ! 750m
  dipAng(12,5,1) =1000.; dipAng(12,5,2) =23.;  dipAng(12,5,3) =15;  dipAng(12,5,4) =20.;   dipAng(12,5,5) =12;      ! 1000m
  dipAng(12,6,1) =1250.; dipAng(12,6,2) =25.;  dipAng(12,6,3) =15;  dipAng(12,6,4) =25.;   dipAng(12,6,5) =12;      ! 1250m
  dipAng(12,7,1) =1500.; dipAng(12,7,2) =28.;  dipAng(12,7,3) =15;  dipAng(12,7,4) =30.;  dipAng(12,7,5) =12;      ! 1500m
  dipAng(12,8,1) =1750.; dipAng(12,8,2) =30.;  dipAng(12,8,3) =15;  dipAng(12,8,4) =35.;  dipAng(12,8,5) =12;      ! 1750m
  dipAng(12,9,1) =2000.; dipAng(12,9,2) =33.;  dipAng(12,9,3) =15;  dipAng(12,9,4) =35.;  dipAng(12,9,5) =12;      ! 2000m
  dipAng(12,10,1)=2250.; dipAng(12,10,2) =38.; dipAng(12,10,3) =15; dipAng(12,10,4) =40.; dipAng(12,10,5) =12;     ! 2250m

  !! shot 13 Up
  dipAng(13,1,1) =0.;    dipAng(13,1,2) =0.;   dipAng(13,1,3) =15;  dipAng(13,1,4) =0.;   dipAng(13,1,5) =12;       ! 0m
  dipAng(13,2,1) =250.;  dipAng(13,2,2) =13.;   dipAng(13,2,3) =15;  dipAng(13,2,4) =10.;   dipAng(13,2,5) =12;      ! 250m
  dipAng(13,3,1) =500.;  dipAng(13,3,2) =18.;   dipAng(13,3,3) =15;  dipAng(13,3,4) =15.;   dipAng(13,3,5) =12;      ! 500m
  dipAng(13,4,1) =750.;  dipAng(13,4,2) =18.;   dipAng(13,4,3) =15;  dipAng(13,4,4) =20.;   dipAng(13,4,5) =12;      ! 750m
  dipAng(13,5,1) =1000.; dipAng(13,5,2) =23.;  dipAng(13,5,3) =15;  dipAng(13,5,4) =20.;   dipAng(13,5,5) =12;      ! 1000m
  dipAng(13,6,1) =1250.; dipAng(13,6,2) =25.;  dipAng(13,6,3) =15;  dipAng(13,6,4) =25.;   dipAng(13,6,5) =12;      ! 1250m
  dipAng(13,7,1) =1500.; dipAng(13,7,2) =28.;  dipAng(13,7,3) =15;  dipAng(13,7,4) =30.;  dipAng(13,7,5) =12;      ! 1500m
  dipAng(13,8,1) =1750.; dipAng(13,8,2) =30.;  dipAng(13,8,3) =15;  dipAng(13,8,4) =35.;  dipAng(13,8,5) =12;      ! 1750m
  dipAng(13,9,1) =2000.; dipAng(13,9,2) =33.;  dipAng(13,9,3) =15;  dipAng(13,9,4) =35.;  dipAng(13,9,5) =12;      ! 2000m
  dipAng(13,10,1)=2250.; dipAng(13,10,2) =38.; dipAng(13,10,3) =15; dipAng(13,10,4) =40.; dipAng(13,10,5) =12;     ! 2250m

  !! shot 14 Up
  dipAng(14,1,1) =0.;    dipAng(14,1,2) =0.;   dipAng(14,1,3) =15;  dipAng(14,1,4) =0.;   dipAng(14,1,5) =12;       ! 0m
  dipAng(14,2,1) =250.;  dipAng(14,2,2) =13.;   dipAng(14,2,3) =15;  dipAng(14,2,4) =10.;   dipAng(14,2,5) =12;      ! 250m
  dipAng(14,3,1) =500.;  dipAng(14,3,2) =18.;   dipAng(14,3,3) =15;  dipAng(14,3,4) =15.;   dipAng(14,3,5) =12;      ! 500m
  dipAng(14,4,1) =750.;  dipAng(14,4,2) =18.;   dipAng(14,4,3) =15;  dipAng(14,4,4) =20.;   dipAng(14,4,5) =12;      ! 750m
  dipAng(14,5,1) =1000.; dipAng(14,5,2) =23.;  dipAng(14,5,3) =15;  dipAng(14,5,4) =20.;   dipAng(14,5,5) =12;      ! 1000m
  dipAng(14,6,1) =1250.; dipAng(14,6,2) =25.;  dipAng(14,6,3) =15;  dipAng(14,6,4) =25.;   dipAng(14,6,5) =12;      ! 1250m
  dipAng(14,7,1) =1500.; dipAng(14,7,2) =28.;  dipAng(14,7,3) =15;  dipAng(14,7,4) =30.;  dipAng(14,7,5) =12;      ! 1500m
  dipAng(14,8,1) =1750.; dipAng(14,8,2) =30.;  dipAng(14,8,3) =15;  dipAng(14,8,4) =35.;  dipAng(14,8,5) =12;      ! 1750m
  dipAng(14,9,1) =2000.; dipAng(14,9,2) =33.;  dipAng(14,9,3) =15;  dipAng(14,9,4) =35.;  dipAng(14,9,5) =12;      ! 2000m
  dipAng(14,10,1)=2250.; dipAng(14,10,2) =38.; dipAng(14,10,3) =15; dipAng(14,10,4) =40.; dipAng(14,10,5) =12;     ! 2250m

  !! shot 15 Up
  dipAng(15,1,1) =0.;    dipAng(15,1,2) =0.;   dipAng(15,1,3) =15;  dipAng(15,1,4) =0.;   dipAng(15,1,5) =12;       ! 0m
  dipAng(15,2,1) =250.;  dipAng(15,2,2) =13.;   dipAng(15,2,3) =15;  dipAng(15,2,4) =10.;   dipAng(15,2,5) =12;      ! 250m
  dipAng(15,3,1) =500.;  dipAng(15,3,2) =18.;   dipAng(15,3,3) =15;  dipAng(15,3,4) =15.;   dipAng(15,3,5) =12;      ! 500m
  dipAng(15,4,1) =750.;  dipAng(15,4,2) =18.;   dipAng(15,4,3) =15;  dipAng(15,4,4) =20.;   dipAng(15,4,5) =12;      ! 750m
  dipAng(15,5,1) =1000.; dipAng(15,5,2) =23.;  dipAng(15,5,3) =15;  dipAng(15,5,4) =20.;   dipAng(15,5,5) =12;      ! 1000m
  dipAng(15,6,1) =1250.; dipAng(15,6,2) =25.;  dipAng(15,6,3) =15;  dipAng(15,6,4) =25.;   dipAng(15,6,5) =12;      ! 1250m
  dipAng(15,7,1) =1500.; dipAng(15,7,2) =28.;  dipAng(15,7,3) =15;  dipAng(15,7,4) =30.;  dipAng(15,7,5) =12;      ! 1500m
  dipAng(15,8,1) =1750.; dipAng(15,8,2) =30.;  dipAng(15,8,3) =15;  dipAng(15,8,4) =35.;  dipAng(15,8,5) =12;      ! 1750m
  dipAng(15,9,1) =2000.; dipAng(15,9,2) =33.;  dipAng(15,9,3) =15;  dipAng(15,9,4) =35.;  dipAng(15,9,5) =12;      ! 2000m
  dipAng(15,10,1)=2250.; dipAng(15,10,2) =38.; dipAng(15,10,3) =15; dipAng(15,10,4) =40.; dipAng(15,10,5) =12;     ! 2250m

  !! shot 16 Up
  dipAng(16,1,1) =0.;    dipAng(16,1,2) =0.;   dipAng(16,1,3) =15;  dipAng(16,1,4) =0.;   dipAng(16,1,5) =15;       ! 0m
  dipAng(16,2,1) =250.;  dipAng(16,2,2) =13.;   dipAng(16,2,3) =14;  dipAng(16,2,4) =5.;   dipAng(16,2,5) =15;      ! 250m
  dipAng(16,3,1) =500.;  dipAng(16,3,2) =18.;   dipAng(16,3,3) =13;  dipAng(16,3,4) =10.;   dipAng(16,3,5) =15;      ! 500m
  dipAng(16,4,1) =750.;  dipAng(16,4,2) =18.;   dipAng(16,4,3) =12;  dipAng(16,4,4) =10.;   dipAng(16,4,5) =15;      ! 750m
  dipAng(16,5,1) =1000.; dipAng(16,5,2) =23.;  dipAng(16,5,3) =12;  dipAng(16,5,4) =15.;   dipAng(16,5,5) =15;      ! 1000m
  dipAng(16,6,1) =1250.; dipAng(16,6,2) =25.;  dipAng(16,6,3) =12;  dipAng(16,6,4) =15.;   dipAng(16,6,5) =15;      ! 1250m
  dipAng(16,7,1) =1500.; dipAng(16,7,2) =28.;  dipAng(16,7,3) =12;  dipAng(16,7,4) =22.;  dipAng(16,7,5) =15;      ! 1500m
  dipAng(16,8,1) =1750.; dipAng(16,8,2) =30.;  dipAng(16,8,3) =12;  dipAng(16,8,4) =22.;  dipAng(16,8,5) =15;      ! 1750m
  dipAng(16,9,1) =2000.; dipAng(16,9,2) =33.;  dipAng(16,9,3) =12;  dipAng(16,9,4) =20.;  dipAng(16,9,5) =15;      ! 2000m
  dipAng(16,10,1)=2250.; dipAng(16,10,2) =38.; dipAng(16,10,3) =12; dipAng(16,10,4) =20.; dipAng(16,10,5) =15;     ! 2250m


end subroutine

!============================================================================

subroutine initiateDipAng_Down()

  !! shot 1 down
  dipAng(1,1,1) =0.;    dipAng(1,1,2) =0.;   dipAng(1,1,3) =12;  dipAng(1,1,4) =0.;   dipAng(1,1,5) =12;       ! 0m
  dipAng(1,2,1) =250.;  dipAng(1,2,2) =10.;   dipAng(1,2,3) =12;  dipAng(1,2,4) =0.;   dipAng(1,2,5) =12;      ! 250m
  dipAng(1,3,1) =500.;  dipAng(1,3,2) =15.;   dipAng(1,3,3) =12;  dipAng(1,3,4) =0.;   dipAng(1,3,5) =12;      ! 500m
  dipAng(1,4,1) =750.;  dipAng(1,4,2) =20.;   dipAng(1,4,3) =12;  dipAng(1,4,4) =0.;   dipAng(1,4,5) =12;      ! 750m
  dipAng(1,5,1) =1000.; dipAng(1,5,2) =20.;  dipAng(1,5,3) =12;  dipAng(1,5,4) =0.;   dipAng(1,5,5) =12;      ! 1000m
  dipAng(1,6,1) =1250.; dipAng(1,6,2) =25.;  dipAng(1,6,3) =12;  dipAng(1,6,4) =0.;   dipAng(1,6,5) =12;      ! 1250m
  dipAng(1,7,1) =1500.; dipAng(1,7,2) =30.;  dipAng(1,7,3) =12;  dipAng(1,7,4) =10.;  dipAng(1,7,5) =12;      ! 1500m
  dipAng(1,8,1) =1750.; dipAng(1,8,2) =35.;  dipAng(1,8,3) =12;  dipAng(1,8,4) =20.;  dipAng(1,8,5) =12;      ! 1750m
  dipAng(1,9,1) =2000.; dipAng(1,9,2) =35.;  dipAng(1,9,3) =12;  dipAng(1,9,4) =30.;  dipAng(1,9,5) =12;      ! 2000m
  dipAng(1,10,1)=2250.; dipAng(1,10,2) =35.; dipAng(1,10,3) =12; dipAng(1,10,4) =40.; dipAng(1,10,5) =12;     ! 2250m

  !! shot 2 down
  dipAng(2,1,1) =0.;    dipAng(2,1,2) =0.;   dipAng(2,1,3) =15;  dipAng(2,1,4) =0.;   dipAng(2,1,5) =12;       ! 0m
  dipAng(2,2,1) =250.;  dipAng(2,2,2) =13.;   dipAng(2,2,3) =15;  dipAng(2,2,4) =10.;   dipAng(2,2,5) =12;      ! 250m
  dipAng(2,3,1) =500.;  dipAng(2,3,2) =20.;   dipAng(2,3,3) =15;  dipAng(2,3,4) =15.;   dipAng(2,3,5) =12;      ! 500m
  dipAng(2,4,1) =750.;  dipAng(2,4,2) =23.;   dipAng(2,4,3) =15;  dipAng(2,4,4) =20.;   dipAng(2,4,5) =12;      ! 750m
  dipAng(2,5,1) =1000.; dipAng(2,5,2) =23.;  dipAng(2,5,3) =15;  dipAng(2,5,4) =20.;   dipAng(2,5,5) =12;      ! 1000m
  dipAng(2,6,1) =1250.; dipAng(2,6,2) =25.;  dipAng(2,6,3) =15;  dipAng(2,6,4) =25.;   dipAng(2,6,5) =12;      ! 1250m
  dipAng(2,7,1) =1500.; dipAng(2,7,2) =28.;  dipAng(2,7,3) =15;  dipAng(2,7,4) =30.;  dipAng(2,7,5) =12;      ! 1500m
  dipAng(2,8,1) =1750.; dipAng(2,8,2) =30.;  dipAng(2,8,3) =15;  dipAng(2,8,4) =35.;  dipAng(2,8,5) =12;      ! 1750m
  dipAng(2,9,1) =2000.; dipAng(2,9,2) =33.;  dipAng(2,9,3) =15;  dipAng(2,9,4) =35.;  dipAng(2,9,5) =12;      ! 2000m
  dipAng(2,10,1)=2250.; dipAng(2,10,2) =38.; dipAng(2,10,3) =15; dipAng(2,10,4) =40.; dipAng(2,10,5) =12;     ! 2250m

  !! shot 3 down
  dipAng(3,1,1) =0.;    dipAng(3,1,2) =0.;   dipAng(3,1,3) =15;  dipAng(3,1,4) =0.;   dipAng(3,1,5) =12;       ! 0m
  dipAng(3,2,1) =250.;  dipAng(3,2,2) =13.;   dipAng(3,2,3) =15;  dipAng(3,2,4) =10.;   dipAng(3,2,5) =12;      ! 250m
  dipAng(3,3,1) =500.;  dipAng(3,3,2) =18.;   dipAng(3,3,3) =15;  dipAng(3,3,4) =15.;   dipAng(3,3,5) =12;      ! 500m
  dipAng(3,4,1) =750.;  dipAng(3,4,2) =18.;   dipAng(3,4,3) =15;  dipAng(3,4,4) =20.;   dipAng(3,4,5) =12;      ! 750m
  dipAng(3,5,1) =1000.; dipAng(3,5,2) =23.;  dipAng(3,5,3) =15;  dipAng(3,5,4) =20.;   dipAng(3,5,5) =12;      ! 1000m
  dipAng(3,6,1) =1250.; dipAng(3,6,2) =25.;  dipAng(3,6,3) =15;  dipAng(3,6,4) =25.;   dipAng(3,6,5) =12;      ! 1250m
  dipAng(3,7,1) =1500.; dipAng(3,7,2) =28.;  dipAng(3,7,3) =15;  dipAng(3,7,4) =30.;  dipAng(3,7,5) =12;      ! 1500m
  dipAng(3,8,1) =1750.; dipAng(3,8,2) =30.;  dipAng(3,8,3) =15;  dipAng(3,8,4) =35.;  dipAng(3,8,5) =12;      ! 1750m
  dipAng(3,9,1) =2000.; dipAng(3,9,2) =33.;  dipAng(3,9,3) =15;  dipAng(3,9,4) =35.;  dipAng(3,9,5) =12;      ! 2000m
  dipAng(3,10,1)=2250.; dipAng(3,10,2) =38.; dipAng(3,10,3) =15; dipAng(3,10,4) =40.; dipAng(3,10,5) =12;     ! 2250m

  !! shot 4 down
  dipAng(4,1,1) =0.;    dipAng(4,1,2) =0.;   dipAng(4,1,3) =15;  dipAng(4,1,4) =0.;   dipAng(4,1,5) =12;       ! 0m
  dipAng(4,2,1) =250.;  dipAng(4,2,2) =13.;   dipAng(4,2,3) =15;  dipAng(4,2,4) =10.;   dipAng(4,2,5) =12;      ! 250m
  dipAng(4,3,1) =500.;  dipAng(4,3,2) =18.;   dipAng(4,3,3) =15;  dipAng(4,3,4) =15.;   dipAng(4,3,5) =12;      ! 500m
  dipAng(4,4,1) =750.;  dipAng(4,4,2) =18.;   dipAng(4,4,3) =15;  dipAng(4,4,4) =20.;   dipAng(4,4,5) =12;      ! 750m
  dipAng(4,5,1) =1000.; dipAng(4,5,2) =23.;  dipAng(4,5,3) =15;  dipAng(4,5,4) =20.;   dipAng(4,5,5) =12;      ! 1000m
  dipAng(4,6,1) =1250.; dipAng(4,6,2) =25.;  dipAng(4,6,3) =15;  dipAng(4,6,4) =25.;   dipAng(4,6,5) =12;      ! 1250m
  dipAng(4,7,1) =1500.; dipAng(4,7,2) =28.;  dipAng(4,7,3) =15;  dipAng(4,7,4) =30.;  dipAng(4,7,5) =12;      ! 1500m
  dipAng(4,8,1) =1750.; dipAng(4,8,2) =30.;  dipAng(4,8,3) =15;  dipAng(4,8,4) =35.;  dipAng(4,8,5) =12;      ! 1750m
  dipAng(4,9,1) =2000.; dipAng(4,9,2) =33.;  dipAng(4,9,3) =15;  dipAng(4,9,4) =35.;  dipAng(4,9,5) =12;      ! 2000m
  dipAng(4,10,1)=2250.; dipAng(4,10,2) =38.; dipAng(4,10,3) =15; dipAng(4,10,4) =40.; dipAng(4,10,5) =12;     ! 2250m

  !! shot 5 down
  dipAng(5,1,1) =0.;    dipAng(5,1,2) =0.;   dipAng(5,1,3) =15;  dipAng(5,1,4) =0.;   dipAng(5,1,5) =12;       ! 0m
  dipAng(5,2,1) =250.;  dipAng(5,2,2) =13.;   dipAng(5,2,3) =15;  dipAng(5,2,4) =10.;   dipAng(5,2,5) =12;      ! 250m
  dipAng(5,3,1) =500.;  dipAng(5,3,2) =18.;   dipAng(5,3,3) =15;  dipAng(5,3,4) =15.;   dipAng(5,3,5) =12;      ! 500m
  dipAng(5,4,1) =750.;  dipAng(5,4,2) =18.;   dipAng(5,4,3) =15;  dipAng(5,4,4) =20.;   dipAng(5,4,5) =12;      ! 750m
  dipAng(5,5,1) =1000.; dipAng(5,5,2) =23.;  dipAng(5,5,3) =15;  dipAng(5,5,4) =20.;   dipAng(5,5,5) =12;      ! 1000m
  dipAng(5,6,1) =1250.; dipAng(5,6,2) =25.;  dipAng(5,6,3) =15;  dipAng(5,6,4) =25.;   dipAng(5,6,5) =12;      ! 1250m
  dipAng(5,7,1) =1500.; dipAng(5,7,2) =28.;  dipAng(5,7,3) =15;  dipAng(5,7,4) =30.;  dipAng(5,7,5) =12;      ! 1500m
  dipAng(5,8,1) =1750.; dipAng(5,8,2) =30.;  dipAng(5,8,3) =15;  dipAng(5,8,4) =35.;  dipAng(5,8,5) =12;      ! 1750m
  dipAng(5,9,1) =2000.; dipAng(5,9,2) =33.;  dipAng(5,9,3) =15;  dipAng(5,9,4) =35.;  dipAng(5,9,5) =12;      ! 2000m
  dipAng(5,10,1)=2250.; dipAng(5,10,2) =38.; dipAng(5,10,3) =15; dipAng(5,10,4) =40.; dipAng(5,10,5) =12;     ! 2250m

  !! shot 6 down
  dipAng(6,1,1) =0.;    dipAng(6,1,2) =0.;   dipAng(6,1,3) =15;  dipAng(6,1,4) =0.;   dipAng(6,1,5) =15;       ! 0m
  dipAng(6,2,1) =250.;  dipAng(6,2,2) =10.;   dipAng(6,2,3) =15;  dipAng(6,2,4) =10.;   dipAng(6,2,5) =15;      ! 250m
  dipAng(6,3,1) =500.;  dipAng(6,3,2) =15.;   dipAng(6,3,3) =15;  dipAng(6,3,4) =15.;   dipAng(6,3,5) =15;      ! 500m
  dipAng(6,4,1) =750.;  dipAng(6,4,2) =20.;   dipAng(6,4,3) =15;  dipAng(6,4,4) =20.;   dipAng(6,4,5) =15;      ! 750m
  dipAng(6,5,1) =1000.; dipAng(6,5,2) =20.;  dipAng(6,5,3) =15;  dipAng(6,5,4) =20.;   dipAng(6,5,5) =15;      ! 1000m
  dipAng(6,6,1) =1250.; dipAng(6,6,2) =25.;  dipAng(6,6,3) =15;  dipAng(6,6,4) =25.;   dipAng(6,6,5) =15;      ! 1250m
  dipAng(6,7,1) =1500.; dipAng(6,7,2) =30.;  dipAng(6,7,3) =15;  dipAng(6,7,4) =30.;  dipAng(6,7,5) =15;      ! 1500m
  dipAng(6,8,1) =1750.; dipAng(6,8,2) =35.;  dipAng(6,8,3) =15;  dipAng(6,8,4) =35.;  dipAng(6,8,5) =15;      ! 1750m
  dipAng(6,9,1) =2000.; dipAng(6,9,2) =35.;  dipAng(6,9,3) =15;  dipAng(6,9,4) =35.;  dipAng(6,9,5) =15;      ! 2000m
  dipAng(6,10,1)=2250.; dipAng(6,10,2) =40.; dipAng(6,10,3) =15; dipAng(6,10,4) =40.; dipAng(6,10,5) =15;     ! 2250m

  !! shot 7 down
  dipAng(7,1,1) =0.;    dipAng(7,1,2) =0.;   dipAng(7,1,3) =15;  dipAng(7,1,4) =0.;   dipAng(7,1,5) =15;       ! 0m
  dipAng(7,2,1) =250.;  dipAng(7,2,2) =10.;   dipAng(7,2,3) =15;  dipAng(7,2,4) =10.;   dipAng(7,2,5) =15;      ! 250m
  dipAng(7,3,1) =500.;  dipAng(7,3,2) =15.;   dipAng(7,3,3) =15;  dipAng(7,3,4) =15.;   dipAng(7,3,5) =15;      ! 500m
  dipAng(7,4,1) =750.;  dipAng(7,4,2) =20.;   dipAng(7,4,3) =15;  dipAng(7,4,4) =20.;   dipAng(7,4,5) =15;      ! 750m
  dipAng(7,5,1) =1000.; dipAng(7,5,2) =20.;  dipAng(7,5,3) =15;  dipAng(7,5,4) =20.;   dipAng(7,5,5) =15;      ! 1000m
  dipAng(7,6,1) =1250.; dipAng(7,6,2) =25.;  dipAng(7,6,3) =15;  dipAng(7,6,4) =25.;   dipAng(7,6,5) =15;      ! 1250m
  dipAng(7,7,1) =1500.; dipAng(7,7,2) =30.;  dipAng(7,7,3) =15;  dipAng(7,7,4) =30.;  dipAng(7,7,5) =15;      ! 1500m
  dipAng(7,8,1) =1750.; dipAng(7,8,2) =35.;  dipAng(7,8,3) =15;  dipAng(7,8,4) =35.;  dipAng(7,8,5) =15;      ! 1750m
  dipAng(7,9,1) =2000.; dipAng(7,9,2) =35.;  dipAng(7,9,3) =15;  dipAng(7,9,4) =35.;  dipAng(7,9,5) =15;      ! 2000m
  dipAng(7,10,1)=2250.; dipAng(7,10,2) =40.; dipAng(7,10,3) =15; dipAng(7,10,4) =40.; dipAng(7,10,5) =15;     ! 2250m

  !! shot 8 down
  dipAng(8,1,1) =0.;    dipAng(8,1,2) =0.;   dipAng(8,1,3) =15;  dipAng(8,1,4) =0.;   dipAng(8,1,5) =15;       ! 0m
  dipAng(8,2,1) =250.;  dipAng(8,2,2) =10.;   dipAng(8,2,3) =15;  dipAng(8,2,4) =10.;   dipAng(8,2,5) =15;      ! 250m
  dipAng(8,3,1) =500.;  dipAng(8,3,2) =15.;   dipAng(8,3,3) =15;  dipAng(8,3,4) =15.;   dipAng(8,3,5) =15;      ! 500m
  dipAng(8,4,1) =750.;  dipAng(8,4,2) =20.;   dipAng(8,4,3) =15;  dipAng(8,4,4) =20.;   dipAng(8,4,5) =15;      ! 750m
  dipAng(8,5,1) =1000.; dipAng(8,5,2) =20.;  dipAng(8,5,3) =15;  dipAng(8,5,4) =20.;   dipAng(8,5,5) =15;      ! 1000m
  dipAng(8,6,1) =1250.; dipAng(8,6,2) =25.;  dipAng(8,6,3) =15;  dipAng(8,6,4) =25.;   dipAng(8,6,5) =15;      ! 1250m
  dipAng(8,7,1) =1500.; dipAng(8,7,2) =30.;  dipAng(8,7,3) =15;  dipAng(8,7,4) =30.;  dipAng(8,7,5) =15;      ! 1500m
  dipAng(8,8,1) =1750.; dipAng(8,8,2) =35.;  dipAng(8,8,3) =15;  dipAng(8,8,4) =35.;  dipAng(8,8,5) =15;      ! 1750m
  dipAng(8,9,1) =2000.; dipAng(8,9,2) =35.;  dipAng(8,9,3) =15;  dipAng(8,9,4) =35.;  dipAng(8,9,5) =15;      ! 2000m
  dipAng(8,10,1)=2250.; dipAng(8,10,2) =40.; dipAng(8,10,3) =15; dipAng(8,10,4) =40.; dipAng(8,10,5) =15;     ! 2250m

  !! shot 9 down
  dipAng(9,1,1) =0.;    dipAng(9,1,2) =0.;   dipAng(9,1,3) =15;  dipAng(9,1,4) =0.;   dipAng(9,1,5) =15;       ! 0m
  dipAng(9,2,1) =250.;  dipAng(9,2,2) =10.;   dipAng(9,2,3) =15;  dipAng(9,2,4) =10.;   dipAng(9,2,5) =15;      ! 250m
  dipAng(9,3,1) =500.;  dipAng(9,3,2) =15.;   dipAng(9,3,3) =15;  dipAng(9,3,4) =15.;   dipAng(9,3,5) =15;      ! 500m
  dipAng(9,4,1) =750.;  dipAng(9,4,2) =20.;   dipAng(9,4,3) =15;  dipAng(9,4,4) =20.;   dipAng(9,4,5) =15;      ! 750m
  dipAng(9,5,1) =1000.; dipAng(9,5,2) =20.;  dipAng(9,5,3) =15;  dipAng(9,5,4) =20.;   dipAng(9,5,5) =15;      ! 1000m
  dipAng(9,6,1) =1250.; dipAng(9,6,2) =25.;  dipAng(9,6,3) =15;  dipAng(9,6,4) =25.;   dipAng(9,6,5) =15;      ! 1250m
  dipAng(9,7,1) =1500.; dipAng(9,7,2) =30.;  dipAng(9,7,3) =15;  dipAng(9,7,4) =30.;  dipAng(9,7,5) =15;      ! 1500m
  dipAng(9,8,1) =1750.; dipAng(9,8,2) =35.;  dipAng(9,8,3) =15;  dipAng(9,8,4) =35.;  dipAng(9,8,5) =15;      ! 1750m
  dipAng(9,9,1) =2000.; dipAng(9,9,2) =35.;  dipAng(9,9,3) =15;  dipAng(9,9,4) =35.;  dipAng(9,9,5) =15;      ! 2000m
  dipAng(9,10,1)=2250.; dipAng(9,10,2) =40.; dipAng(9,10,3) =15; dipAng(9,10,4) =40.; dipAng(9,10,5) =15;     ! 2250m

  !! shot 10 down
  dipAng(10,1,1) =0.;    dipAng(10,1,2) =0.;   dipAng(10,1,3) =15;  dipAng(10,1,4) =0.;   dipAng(10,1,5) =15;       ! 0m
  dipAng(10,2,1) =250.;  dipAng(10,2,2) =10.;   dipAng(10,2,3) =15;  dipAng(10,2,4) =10.;   dipAng(10,2,5) =15;      ! 250m
  dipAng(10,3,1) =500.;  dipAng(10,3,2) =15.;   dipAng(10,3,3) =15;  dipAng(10,3,4) =15.;   dipAng(10,3,5) =15;      ! 500m
  dipAng(10,4,1) =750.;  dipAng(10,4,2) =20.;   dipAng(10,4,3) =15;  dipAng(10,4,4) =20.;   dipAng(10,4,5) =15;      ! 750m
  dipAng(10,5,1) =1000.; dipAng(10,5,2) =20.;  dipAng(10,5,3) =15;  dipAng(10,5,4) =20.;   dipAng(10,5,5) =15;      ! 1000m
  dipAng(10,6,1) =1250.; dipAng(10,6,2) =25.;  dipAng(10,6,3) =15;  dipAng(10,6,4) =25.;   dipAng(10,6,5) =15;      ! 1250m
  dipAng(10,7,1) =1500.; dipAng(10,7,2) =30.;  dipAng(10,7,3) =15;  dipAng(10,7,4) =30.;  dipAng(10,7,5) =15;      ! 1500m
  dipAng(10,8,1) =1750.; dipAng(10,8,2) =35.;  dipAng(10,8,3) =15;  dipAng(10,8,4) =35.;  dipAng(10,8,5) =15;      ! 1750m
  dipAng(10,9,1) =2000.; dipAng(10,9,2) =35.;  dipAng(10,9,3) =15;  dipAng(10,9,4) =35.;  dipAng(10,9,5) =15;      ! 2000m
  dipAng(10,10,1)=2250.; dipAng(10,10,2) =40.; dipAng(10,10,3) =15; dipAng(10,10,4) =40.; dipAng(10,10,5) =15;     ! 2250m

  !! shot 11 down
  dipAng(11,1,1) =0.;    dipAng(11,1,2) =0.;   dipAng(11,1,3) =15;  dipAng(11,1,4) =0.;   dipAng(11,1,5) =15;       ! 0m
  dipAng(11,2,1) =250.;  dipAng(11,2,2) =10.;   dipAng(11,2,3) =15;  dipAng(11,2,4) =10.;   dipAng(11,2,5) =15;      ! 250m
  dipAng(11,3,1) =500.;  dipAng(11,3,2) =15.;   dipAng(11,3,3) =15;  dipAng(11,3,4) =15.;   dipAng(11,3,5) =15;      ! 500m
  dipAng(11,4,1) =750.;  dipAng(11,4,2) =20.;   dipAng(11,4,3) =15;  dipAng(11,4,4) =20.;   dipAng(11,4,5) =15;      ! 750m
  dipAng(11,5,1) =1000.; dipAng(11,5,2) =20.;  dipAng(11,5,3) =15;  dipAng(11,5,4) =20.;   dipAng(11,5,5) =15;      ! 1000m
  dipAng(11,6,1) =1250.; dipAng(11,6,2) =25.;  dipAng(11,6,3) =15;  dipAng(11,6,4) =25.;   dipAng(11,6,5) =15;      ! 1250m
  dipAng(11,7,1) =1500.; dipAng(11,7,2) =30.;  dipAng(11,7,3) =15;  dipAng(11,7,4) =30.;  dipAng(11,7,5) =15;      ! 1500m
  dipAng(11,8,1) =1750.; dipAng(11,8,2) =35.;  dipAng(11,8,3) =15;  dipAng(11,8,4) =35.;  dipAng(11,8,5) =15;      ! 1750m
  dipAng(11,9,1) =2000.; dipAng(11,9,2) =35.;  dipAng(11,9,3) =15;  dipAng(11,9,4) =35.;  dipAng(11,9,5) =15;      ! 2000m
  dipAng(11,10,1)=2250.; dipAng(11,10,2) =40.; dipAng(11,10,3) =15; dipAng(11,10,4) =40.; dipAng(11,10,5) =15;     ! 2250m

  !! shot 12 down
  dipAng(12,1,1) =0.;    dipAng(12,1,2) =0.;   dipAng(12,1,3) =15;  dipAng(12,1,4) =0.;   dipAng(12,1,5) =15;       ! 0m
  dipAng(12,2,1) =250.;  dipAng(12,2,2) =13.;   dipAng(12,2,3) =15;  dipAng(12,2,4) =10.;   dipAng(12,2,5) =15;      ! 250m
  dipAng(12,3,1) =500.;  dipAng(12,3,2) =18.;   dipAng(12,3,3) =15;  dipAng(12,3,4) =15.;   dipAng(12,3,5) =15;      ! 500m
  dipAng(12,4,1) =750.;  dipAng(12,4,2) =18.;   dipAng(12,4,3) =15;  dipAng(12,4,4) =20.;   dipAng(12,4,5) =15;      ! 750m
  dipAng(12,5,1) =1000.; dipAng(12,5,2) =23.;  dipAng(12,5,3) =15;  dipAng(12,5,4) =20.;   dipAng(12,5,5) =15;      ! 1000m
  dipAng(12,6,1) =1250.; dipAng(12,6,2) =25.;  dipAng(12,6,3) =15;  dipAng(12,6,4) =25.;   dipAng(12,6,5) =15;      ! 1250m
  dipAng(12,7,1) =1500.; dipAng(12,7,2) =28.;  dipAng(12,7,3) =15;  dipAng(12,7,4) =30.;  dipAng(12,7,5) =15;      ! 1500m
  dipAng(12,8,1) =1750.; dipAng(12,8,2) =30.;  dipAng(12,8,3) =15;  dipAng(12,8,4) =35.;  dipAng(12,8,5) =15;      ! 1750m
  dipAng(12,9,1) =2000.; dipAng(12,9,2) =33.;  dipAng(12,9,3) =15;  dipAng(12,9,4) =35.;  dipAng(12,9,5) =15;      ! 2000m
  dipAng(12,10,1)=2250.; dipAng(12,10,2) =38.; dipAng(12,10,3) =15; dipAng(12,10,4) =40.; dipAng(12,10,5) =15;     ! 2250m

  !! shot 13 down
  dipAng(13,1,1) =0.;    dipAng(13,1,2) =0.;   dipAng(13,1,3) =15;  dipAng(13,1,4) =0.;   dipAng(13,1,5) =15;       ! 0m
  dipAng(13,2,1) =250.;  dipAng(13,2,2) =13.;   dipAng(13,2,3) =15;  dipAng(13,2,4) =10.;   dipAng(13,2,5) =15;      ! 250m
  dipAng(13,3,1) =500.;  dipAng(13,3,2) =18.;   dipAng(13,3,3) =15;  dipAng(13,3,4) =15.;   dipAng(13,3,5) =15;      ! 500m
  dipAng(13,4,1) =750.;  dipAng(13,4,2) =18.;   dipAng(13,4,3) =15;  dipAng(13,4,4) =20.;   dipAng(13,4,5) =15;      ! 750m
  dipAng(13,5,1) =1000.; dipAng(13,5,2) =23.;  dipAng(13,5,3) =15;  dipAng(13,5,4) =20.;   dipAng(13,5,5) =15;      ! 1000m
  dipAng(13,6,1) =1250.; dipAng(13,6,2) =25.;  dipAng(13,6,3) =15;  dipAng(13,6,4) =25.;   dipAng(13,6,5) =15;      ! 1250m
  dipAng(13,7,1) =1500.; dipAng(13,7,2) =28.;  dipAng(13,7,3) =15;  dipAng(13,7,4) =30.;  dipAng(13,7,5) =15;      ! 1500m
  dipAng(13,8,1) =1750.; dipAng(13,8,2) =30.;  dipAng(13,8,3) =15;  dipAng(13,8,4) =35.;  dipAng(13,8,5) =15;      ! 1750m
  dipAng(13,9,1) =2000.; dipAng(13,9,2) =33.;  dipAng(13,9,3) =15;  dipAng(13,9,4) =35.;  dipAng(13,9,5) =15;      ! 2000m
  dipAng(13,10,1)=2250.; dipAng(13,10,2) =38.; dipAng(13,10,3) =15; dipAng(13,10,4) =40.; dipAng(13,10,5) =15;     ! 2250m

  !! shot 14 down
  dipAng(14,1,1) =0.;    dipAng(14,1,2) =0.;   dipAng(14,1,3) =15;  dipAng(14,1,4) =0.;   dipAng(14,1,5) =15;       ! 0m
  dipAng(14,2,1) =250.;  dipAng(14,2,2) =13.;   dipAng(14,2,3) =15;  dipAng(14,2,4) =10.;   dipAng(14,2,5) =15;      ! 250m
  dipAng(14,3,1) =500.;  dipAng(14,3,2) =18.;   dipAng(14,3,3) =15;  dipAng(14,3,4) =15.;   dipAng(14,3,5) =15;      ! 500m
  dipAng(14,4,1) =750.;  dipAng(14,4,2) =18.;   dipAng(14,4,3) =15;  dipAng(14,4,4) =20.;   dipAng(14,4,5) =15;      ! 750m
  dipAng(14,5,1) =1000.; dipAng(14,5,2) =23.;  dipAng(14,5,3) =15;  dipAng(14,5,4) =20.;   dipAng(14,5,5) =15;      ! 1000m
  dipAng(14,6,1) =1250.; dipAng(14,6,2) =25.;  dipAng(14,6,3) =15;  dipAng(14,6,4) =25.;   dipAng(14,6,5) =15;      ! 1250m
  dipAng(14,7,1) =1500.; dipAng(14,7,2) =28.;  dipAng(14,7,3) =15;  dipAng(14,7,4) =30.;  dipAng(14,7,5) =15;      ! 1500m
  dipAng(14,8,1) =1750.; dipAng(14,8,2) =30.;  dipAng(14,8,3) =15;  dipAng(14,8,4) =35.;  dipAng(14,8,5) =15;      ! 1750m
  dipAng(14,9,1) =2000.; dipAng(14,9,2) =33.;  dipAng(14,9,3) =15;  dipAng(14,9,4) =35.;  dipAng(14,9,5) =15;      ! 2000m
  dipAng(14,10,1)=2250.; dipAng(14,10,2) =38.; dipAng(14,10,3) =15; dipAng(14,10,4) =40.; dipAng(14,10,5) =15;     ! 2250m

  !! shot 15 down
  dipAng(15,1,1) =0.;    dipAng(15,1,2) =0.;   dipAng(15,1,3) =15;  dipAng(15,1,4) =0.;   dipAng(15,1,5) =15;       ! 0m
  dipAng(15,2,1) =250.;  dipAng(15,2,2) =13.;   dipAng(15,2,3) =14;  dipAng(15,2,4) =10.;   dipAng(15,2,5) =15;      ! 250m
  dipAng(15,3,1) =500.;  dipAng(15,3,2) =18.;   dipAng(15,3,3) =13;  dipAng(15,3,4) =15.;   dipAng(15,3,5) =15;      ! 500m
  dipAng(15,4,1) =750.;  dipAng(15,4,2) =18.;   dipAng(15,4,3) =12;  dipAng(15,4,4) =20.;   dipAng(15,4,5) =15;      ! 750m
  dipAng(15,5,1) =1000.; dipAng(15,5,2) =23.;  dipAng(15,5,3) =12;  dipAng(15,5,4) =25.;   dipAng(15,5,5) =15;      ! 1000m
  dipAng(15,6,1) =1250.; dipAng(15,6,2) =25.;  dipAng(15,6,3) =12;  dipAng(15,6,4) =30.;   dipAng(15,6,5) =15;      ! 1250m
  dipAng(15,7,1) =1500.; dipAng(15,7,2) =28.;  dipAng(15,7,3) =12;  dipAng(15,7,4) =35.;  dipAng(15,7,5) =15;      ! 1500m
  dipAng(15,8,1) =1750.; dipAng(15,8,2) =30.;  dipAng(15,8,3) =12;  dipAng(15,8,4) =40.;  dipAng(15,8,5) =15;      ! 1750m
  dipAng(15,9,1) =2000.; dipAng(15,9,2) =33.;  dipAng(15,9,3) =12;  dipAng(15,9,4) =40.;  dipAng(15,9,5) =15;      ! 2000m
  dipAng(15,10,1)=2250.; dipAng(15,10,2) =38.; dipAng(15,10,3) =12; dipAng(15,10,4) =45.; dipAng(15,10,5) =15;     ! 2250m

  !! shot 16 down
  dipAng(16,1,1) =0.;    dipAng(16,1,2) =0.;   dipAng(16,1,3) =15;  dipAng(16,1,4) =0.;   dipAng(16,1,5) =15;       ! 0m
  dipAng(16,2,1) =250.;  dipAng(16,2,2) =13.;   dipAng(16,2,3) =14;  dipAng(16,2,4) =10.;   dipAng(16,2,5) =15;      ! 250m
  dipAng(16,3,1) =500.;  dipAng(16,3,2) =18.;   dipAng(16,3,3) =13;  dipAng(16,3,4) =15.;   dipAng(16,3,5) =15;      ! 500m
  dipAng(16,4,1) =750.;  dipAng(16,4,2) =18.;   dipAng(16,4,3) =12;  dipAng(16,4,4) =20.;   dipAng(16,4,5) =15;      ! 750m
  dipAng(16,5,1) =1000.; dipAng(16,5,2) =23.;  dipAng(16,5,3) =12;  dipAng(16,5,4) =25.;   dipAng(16,5,5) =15;      ! 1000m
  dipAng(16,6,1) =1250.; dipAng(16,6,2) =25.;  dipAng(16,6,3) =12;  dipAng(16,6,4) =30.;   dipAng(16,6,5) =15;      ! 1250m
  dipAng(16,7,1) =1500.; dipAng(16,7,2) =28.;  dipAng(16,7,3) =12;  dipAng(16,7,4) =35.;  dipAng(16,7,5) =15;      ! 1500m
  dipAng(16,8,1) =1750.; dipAng(16,8,2) =30.;  dipAng(16,8,3) =12;  dipAng(16,8,4) =40.;  dipAng(16,8,5) =15;      ! 1750m
  dipAng(16,9,1) =2000.; dipAng(16,9,2) =33.;  dipAng(16,9,3) =12;  dipAng(16,9,4) =40.;  dipAng(16,9,5) =15;      ! 2000m
  dipAng(16,10,1)=2250.; dipAng(16,10,2) =38.; dipAng(16,10,3) =12; dipAng(16,10,4) =45.; dipAng(16,10,5) =15;     ! 2250m


end subroutine

!============================================================================

subroutine weightcone(weightArr,nkz,nkh,dkz,dkh,okz,okh,shotnum,x,xshot)

! assume zeros is in the middle of the axis
integer           		:: nkz, nkh, ikz, ikh, ii, icur
integer                         :: shotnum, posneg, angind, rangind, irange, nrange
real                            :: zerokz, zerokh, x, xshot, diffX, absdiffX
real               		:: dkh, okh, dkz, okz, kz,kh
real                            :: theta, val, signX, fac1
real,dimension(:,:)             :: weightArr

   zerokz = (0.-okz)/dkz+0.5
   zerokh = (0.-okh)/dkh+0.5


 ! Initialization
  do ikh=1,nkh
    do ikz=1,nkz
       	 weightArr(ikz,ikh) = 0.
    end do
  end do

  if ( (shotnum .lt. 1) .or. (shotnum .gt. 16)) call erexit("shotnum should be between 1 and 16")

!  (1) x<xshot allow positive dip
!  (2) x~xshot allow horizontal di
!  (3) x>xshot allow negative dip 

   diffX = x-xshot


   absdiffX = abs(diffX)
   signX = -1*diffX/absdiffX

   if (signX .gt. 0) then
     posneg = 1
   else 
     posneg = 0
   end if
   angind=posneg*2+2
   rangind=posneg*2+3

   do ii = 1,10
      if (absdiffX .lt. dipAng(shotnum,ii,1) ) then
        icur = ii-1
        exit;
      else
        icur = 10
      end if
   end do 

   if (absdiffX .gt. dipAng(shotnum,10,1)) then
      theta = signX*dipAng(shotnum,10,angind)
      icur=10
   else if (absdiffX .lt. 10) then
      theta = 0.
      icur=1
   else
     fac1 = (absdiffX-dipAng(shotnum,icur,1))/250.
     theta = fac1*(dipAng(shotnum,icur+1,angind)-dipAng(shotnum,icur,angind))+dipAng(shotnum,icur,angind)
     theta = signX*theta
   end if

   ! Theta is in degrees
   nrange = int(dipAng(shotnum,icur,rangind))
!   if (mod(absdiffX,100.) .eq. 0) write(0,*) 'diffX, theta, xrange', diffX, theta, nrange
   call LineWeightAng(weightArr,nkz,dkz,okz,nkh,dkh,okh,theta)
   do irange=1,nrange    
     call LineWeightAng(weightArr,nkz,dkz,okz,nkh,dkh,okh,theta+irange)
     call LineWeightAng(weightArr,nkz,dkz,okz,nkh,dkh,okh,theta-irange)
   end do

   call triangle2( 5, 2, nkz, nkh, weightArr, weightArr)

   do ikh=1,nkh
      do ikz=1,nkz
         val = abs(weightArr(ikz,ikh))
         if (val .gt. 0) weightArr(ikz,ikh) = 1.
      end do
   end do

   call triangle2( 5, 3, nkz, nkh, weightArr, weightArr)

   if (3 > 5) then
     call sep_write(weightArr, "weightArr.H");
     call auxputch("n1",'i', nkz, "weightArr.H");      call auxputch("label1",'s', 'kz', "weightArr.H"); 
     call auxputch("d1",'f', dkz, "weightArr.H");      call auxputch("o1",'f', okz, "weightArr.H");
     call auxputch("n2",'i', nkh, "weightArr.H");  call auxputch("label2",'s', 'kh', "weightArr.H"); 
     call auxputch("d2",'f', dkh, "weightArr.H");      call auxputch("o2",'f', okh, "weightArr.H");
     call erexit('exxit noww')
   end if


end subroutine


!=======================================================================
subroutine LineWeightAng(weightArr,nkz,dkz,okz,nkh,dkh,okh,theta_deg)

   integer          :: ikz, nkz, ikh, nkh
   integer          :: izerokh, izerokz
   real             :: dkz, okz, dkh, okh
   real             :: theta_deg, theta_rad, dtheta, kz, kh
   real, dimension(:,:)  :: weightArr

   izerokh = (0.-okh)/dkh+0.5
   izerokz = (0.-okz)/dkz+0.5
   dtheta = 0.1*ppi/180.
   theta_rad = theta_deg*ppi/180.

 !  write(0,*) 'LineWeightAng', theta_deg, theta_rad, dtheta

   if (abs(theta_rad) .lt. dtheta) then
      weightArr(:,izerokh) = 1.
   else if (abs(theta_deg) .gt. 87) then
      weightArr(izerokz,:) = 1.
   else
     do ikz=1,nkz

        kz = (ikz-1)*dkz+okz
        kh = kz*tan(theta_rad)
        ikh = (kh-okh)/dkh+0.5
        if ((ikh .gt. 1) .and. (ikh .lt. nkh) ) then
           weightArr(ikz,ikh) = 1.
        end if
   !     write(0,*) 'ikz', ikz
     end do
   end if
 
end subroutine
!=======================================================================
subroutine EdgeTaper(weightArr,n1,n2,a1,a2)

  integer     :: n1,n2,a1,a2
  integer     :: i1, i2
  real        :: val1, val2, mul
  real, dimension(:,:) :: weightArr


  ! Top and bottom
  do i1=1,a1
     val1 = cos((a1-i1)*1.0/a1*ppi/2)
 !    write(0,*) 'i1, val1, a1', i1, val1, a1
     weightArr(i1,:) = weightArr(i1,:)*val1
     weightArr(n1-i1+1,:) = weightArr(n1-i1+1,:)*val1
  end do

  ! Left and right 
  do i2=1,a2
     val2 = cos((a2-i2)*1.0/a2*ppi/2)
  !!   write(0,*) 'i2, val2, a2', i2, val2, a2
     weightArr(:,i2) = weightArr(:,i2)*val2
     weightArr(:,n2-i2+1) = weightArr(:,n2-i2+1)*val2
  end do

end subroutine

end module
