program myZero
! Create a file of zeros with specified dims
! Input:  naxis
! Input: n1,o1,d1, n2,o2,d2, ... etc uptil naxis


  use sep
  use waveprop3d_mod
  use type3d_mod
  use smooth3d_mod

  integer                   :: naxis, nvolume
  integer                   :: n1,n2,n3,n4,n5
  integer                   :: i
  real                      :: eps
  real                      :: o1, o2, o3, o4, o5
  real                      :: d1, d2, d3, d4, d5
  real, dimension(:), allocatable :: inArray
  character(len=128)        :: label1, label2, label3, label4, label5

  call sep_init()

  call from_param("naxis",naxis);



  if ((naxis .gt. 5) .or. (naxis .lt. 1) ) call erexit('naxis must be between 1 to 5')
  
  n1=1.; n2=1.; n3=1.;  n4=1.; n5=1.;

  if(naxis .ge. 1) then
     call from_param( "n1", n1);    call from_param("d1",d1);     call from_param( "o1",o1);
     call from_param( "label1",label1,'z');
  end if
  
  if (naxis .ge. 2) then
     call from_param( "n2", n2);    call from_param("d2",d2);     call from_param( "o2",o2);
     call from_param( "label2",label2,'x');
  end if
  
  if(naxis .ge. 3) then
     call from_param( "n3", n3);    call from_param("d3",d3,1.);     call from_param( "o3",o3,0.);
     call from_param( "label3",label3,'y');
  end if
  
  if (naxis .ge. 4) then
     call from_param( "n4", n4);    call from_param("d4",d4);     call from_param( "o4",o4);
     call from_param( "label4",label4,'hx');
  end if
  
  if (naxis .ge. 5) then
     call from_param( "n5", n5);    call from_param("d5",d5);     call from_param( "o5",o5);
     call from_param( "label5",label5,'hy');
  end if

  nvolume=n1*n2*n3*n4*n5
  allocate(inArray(nvolume))
  inArray = 0.



     if (naxis .ge. 1) then
         call to_history("n1",n1);     
         call to_history("d1",d1);   
         call to_history("o1",o1);
         call to_history("label1",label1);
     end if
     if (naxis .ge. 2) then
	  call to_history("n2",n2);     
	  call to_history("d2",d2);   
	  call to_history("o2",o2);
          call to_history("label2",label2);
     end if
     if (naxis .ge. 3) then
	  call to_history("n3",n3);     
	  call to_history("d3",d3);   
	  call to_history("o3",o3);
          call to_history("label3",label3);
     end if
     if (naxis .ge. 4) then
	  call to_history("n4",n4);     
	  call to_history("d4",d4);   
	  call to_history("o4",o4);
          call to_history("label4",label4);
     end if
     if (naxis .ge. 5) then
	  call to_history("n5",n5);     
	  call to_history("d5",d5);   
	  call to_history("o5",o5);
          call to_history("label5",label5);
     end if
     
     call sep_write(inArray);


end program
