#! /usr/bin/env python
#from SEP import *
import commands as cmd
import re,string
import sys, os
import os.path as path


sys.path.append('/net/server/homes/sep/mandyman/research/data/Cascadia_OBS/LSM/pycode')
from pyLOC import *


import pyInvmodRegJoint
import pyfirstiterRegJoint

# ----------------------------------------------------------------
# ----- Project specific Definition -------- *** Need Changing ***
# ----------------------------------------------------------------

# Please make sure pyAdjoint and pyForward include the proper pyLOC.py file that contains the location of the nodes
# L = [[0],['A',GxA,GyA,GzA],['B',GxB,GyB,GzB],['C',GxC,GyC,GzC], ...]

#maindir = "."
maindir = "/net/server/homes/sep/mandyman/research/data/Cascadia_OBS/LSM" # where souwfld, syndat, Input, bin 
projdir = maindir + "/7shots/L2M"            # Project directory, where all intermediate output stored
plet = 'M'                                  # Project letter (to avoid overwrite in scr)

# ---- OBS Horizontal location -----------------------------------
# Note: vertical position is saved in a file 'zloc.H' ------------
#       assume nshot <=100 or else Add doesn't work --------------
K=[1,2,3,6,7,10]                        # shot number to calculate

# ---- File names and project directories ----------------
velfile= 'velCas2D.H'              # vel file (located at projdir/Input/.)
parAdj= 'AdjCasA.par'                   # Adjoint param file (located at projdir/Par/.)
parFor= 'ForCasA.par'                   # Forward param file (located at projdir/Par/.)
dirdata = 'syndat/B/sdCasB'

souwfldup =  'souwfld/Ctape/swCasCTape' 
souwflddn =  'souwfld/D/swCasD'
ampfile =  maindir + '/souwfld/C/ampCasCTotal.H'         # Amplitude balancing files
DWfile  = 'syndat/DatWgt1/tmWgt'       # Data weighting files
MWfile  =  'souwfld/A/const1.H'         # Model weighting files

# ---------- Preconditioning and Regularization -----------------------
Rname = 'Iden.x'                           # Program name for regularization operation
eps   = 0.2                                # Epsilon is 20% between ratio of initial ggmDggm and ggDgg
ratio = 0.                                 # Initialization for ggdDggd/ggmDggm
smooth = 0                                    
lpfil  = 0
gauss  = 0
VDer   = 0
ampba  = 0                                 # [0]=none, 1=Joint, 2=down, 3=up
DW     = 1                                 # Data space weighting

# ---- Image space parameters ---------------
modax = 2                                  # number of axis in image file
nmz = 80                                   # nz 
omz = 1200.                                # oz
dmz = 10.                                  # dz
nmx = 1200                                # nx
omx = 2500.                                # ox
dmx = 10.                                  # dx


# --- Data space parameters ----------------
datax = 3                               # number of axis in data space

# ----- Iteration loop ----------------------
biter = 1                              # Beginning iteration
eiter = 20                             # End iteration


# ----------------------------------------------------------------
# ------- End of Definition --------------------------------------
# ----------------------------------------------------------------

dirm  = projdir+'/m/mCas'+plet
dirs  = projdir+'/s/sCas'+plet
dirdm = projdir+'/dm/dmCas'+plet
dirgg = projdir+'/gg/ggCas'+plet
dirss = projdir+'/ss/ssCas'+plet
dirrr = projdir+'/rr/rrCas'+plet

dirggm = projdir+'/ggm/ggmCas'+plet
dirssm = projdir+'/ssm/ssmCas'+plet
dirrrm = projdir+'/rrm/rrmCas'+plet
dmm    = projdir + '/dm/dmMCas'+plet

os.system("cd ..")
os.system("make bin/modcgstep.x")
os.system("make bin/LsqMig_MainJoint.x")
os.system("make bin/ForwardJoint.x")
os.system("make bin/updateAB.x")
os.system("make bin/Solver_ops.x")
os.system("make bin/ApplyWgt.x")
os.system("make bin/ModWgt.x")

cmd1= 'make bin/%s'%(Rname)
os.system(cmd1)


# Step 00: Creat model weighting files
#cmd1 = "%s/bin/ModWgt.x < %sTotaliter1.H ampba=%s ampfile=%s outfile=t1.H Wgtfile=%s >/dev/null"%(maindir,dirm,ampba,ampfile,MWfile)
#cmd1 = "Math file1=%s > %s"%(nmz,nmx,omz,omx,dmz,dmx,MWfile)
#print cmd1
#os.system(cmd1)	


if (biter == 1):
	pyfirstiterRegJoint.run(maindir,projdir,velfile,parFor,parAdj, plet,K,nmz,omz,dmz,nmx,omx,dmx,modax,datax,dirdata,smooth,lpfil,VDer, gauss, DW, souwfldup, souwflddn, ampba, ampfile,  MWfile, DWfile, Rname,eps,ratio)
	biter = biter+1


# At this point, iter 1 is already finished, so calculate ratio
ratio = pyInvmodRegJoint.Ratio(maindir,projdir,plet,K,Rname,modax,datax,1)
print 'ggmDggm vs ggdDggd ratio', ratio

for iter in range(biter,eiter+1):



	print 'Running iteration#', iter
	
	# Step 2: Loop shots  dm = F'Rd  + eps A' Rm
	if (iter != -1*biter):
		pyInvmodRegJoint.Adjoint(maindir, projdir, velfile, parAdj, plet, K, smooth, lpfil,VDer, gauss, DW, souwfldup, souwflddn, MWfile, DWfile, Rname, eps, ratio, modax, iter)

        # Step 3: Calculate dmTotal
	if (iter != -1*biter):
		pyInvmodRegJoint.Add(dirdm, iter, modax, K,dmm)

	# Step 4: Loop shots  gg = Fdm and ggm= eps A dm        
	if (iter != -1*biter):
		pyInvmodRegJoint.Forward(maindir, projdir, velfile, parFor, plet, K, smooth, lpfil,VDer, gauss, DW, souwfldup, souwflddn, MWfile, DWfile, Rname, eps, ratio, modax, iter)
			        
        
        
        # Step 5: Calculate the alpha and beta in conjugate direction
        alpha, beta, resid = pyInvmodRegJoint.DPcalCD(projdir, plet, K,iter,datax,modax, dirdm, dirggm, dirgg, dirrr, dirrrm, dirss, dirssm)
	print alpha, beta, resid

	

	#  Step 6: Update the residual files
	print 'update data residual, iter', iter
	for i in K[:]:
        	print 'residual update, iter', iter, 'shot', i
                #  calculate your ss file ss=alpha*dr+beta*ss	
        	C1 = "bin/updateAB.x alpha=%s beta=%s naxis=%s file1=%s%siter%s.H file2=%s%siter%s.H outfile=%s%siter%s.H >/dev/null"%(alpha,beta,datax,dirgg,i,iter,dirss,i,iter,dirss,i,iter+1)
		os.system(C1)
			             
		#  update your current residual here  rr=rr+ss
		C1 = "bin/updateAB.x alpha=1.0 beta=1.0 naxis=%s file1=%s%siter%s.H file2=%s%siter%s.H outfile=%s%siter%s.H >/dev/null"%(datax,dirrr,i,iter,dirss,i,iter+1,dirrr,i,iter+1)	
		os.system(C1)


	#Step 6b: Update the  model residual files
	print 'update model residual, iter', iter
	# calculate ssm = alpha*ggm 
	C1 = "bin/updateAB.x alpha=%s cg=1 naxis=%s file1=%siter%s.H outfile=%siter%s.H >/dev/null"%(alpha,modax,dirggm,iter,dirssm,iter+1)
	print C1	
	os.system(C1)  
	# Calculate your new rrm = rrm + ssm
	C1 = "bin/updateAB.x alpha=1.0 beta=1.0 naxis=%s file1=%siter%s.H file2=%siter%s.H outfile=%siter%s.H >/dev/null"%(modax,dirrrm,iter,dirssm,iter+1,dirrrm,iter+1)	
	print C1
	os.system(C1)

	
	# Step 7: Update the model files
	# Calculate your new dm s=alpha*dm+beta*s
	print 'model update, iter', iter
	C1 = "bin/updateAB.x alpha=%s beta=%s naxis=%s file1=%sTotaliter%s.H file2=%sTotaliter%s.H outfile=%sTotaliter%s.H >/dev/null"%(alpha,beta,modax,dirdm,iter,dirs,iter,dirs,iter+1)	
	print C1
	os.system(C1)  
	# Calculate your new m
	C1 = "bin/updateAB.x alpha=1.0 beta=1.0 naxis=%s file1=%sTotaliter%s.H file2=%sTotaliter%s.H outfile=%sTotaliter%s.H >/dev/null"%(modax,dirm,iter,dirs,iter+1,dirm,iter+1)	
	print C1
	os.system(C1)
       
        # Step 9, remove files
##	pyInvmodRegJoint.removefiles(maindir,nblock,dboc,osx,dsx,iter,nitersave,saveshot)


# Calculate final residuals and save to report
resid = pyInvmodRegJoint.ResidCal(projdir, plet,K,iter+1,datax,dirrr)
print  resid
file = open(projdir+'/Reportsave.txt', 'a')              # save to report
cmd1 = " %s na na %s \n"%(iter, resid)
file.writelines(cmd1);
file.close()
