#! /usr/bin/env python
#from SEP import *
import commands as cmd
import re,string
import sys, os
import os.path as path
sys.path.append('./pycode')
from pyBath import * 

# This code submit the jobs for 3D Migration

# Get job parameters
shot = int(sys.argv[1])
jobname = sys.argv[2]
iter = int(sys.argv[3])
outdir = sys.argv[4]
projdir = sys.argv[5]
plet    = sys.argv[6]
velfile = sys.argv[7]
parfile = sys.argv[8]
smooth  = sys.argv[9]
lpfil   = sys.argv[10]
VDer    = sys.argv[11]
gauss   = sys.argv[12]
DW      = sys.argv[13]
nhx     = sys.argv[14]
souwfld = sys.argv[15]
MWfile = sys.argv[16]
DWfile  = sys.argv[17]
dirrr = sys.argv[18]
dirdm = sys.argv[19]
UD = int(sys.argv[20])

nodes = 1   # number of nodes for each job
ppn=8     # number of processor per node
walltime='24:00:00'  # max time to wait for the job to finish
pmem = '5gb'  # max memory to allocate for the job

os.system("rm -f %s/out2.par; sed '/#/d' Par/%s | sed '/^$/d' | tr '\n' ' ' > %s/out2.par"%(projdir,parfile,projdir))
f1 = open("%s/out2.par"%(projdir))
param = f1.readline()
f1.close()
#print 'parfile', parfile
#print '%s/out2.par'%(projdir)
#print 'param', param

# Constructing logfile and cmdfile
if (os.path.isdir('%s/pbs'%(outdir)) != 1):
	os.system('mkdir %s/pbs'%(outdir))
if (os.path.isdir('%s/logfile'%(outdir)) != 1):
	os.system('mkdir %s/logfile'%(outdir))
cmdfile = "%s/pbs/PBS%s%sUD%s.txt"%(outdir,plet,shot,UD)
logfile = "%s/logfile/Adj%sUD%s.txt"%(outdir,shot,UD)
os.system("rm -f %s %s"%(cmdfile,logfile))

# Get Source wfld file index and data masking param
bfile = swfile[shot][2*int(UD)-1]
efile = swfile[shot][2*int(UD)]

dt=ForwardTime[0][0]
nt=ForwardTime[0][2*int(UD)-1]
ot=ForwardTime[0][2*int(UD)]

cmd0 ='python pycode/pyRemove.py  %s%siter%s.H '%(dirdm,shot,iter)

Gx = L[int(shot)][1]  # get shot x

cmd1 = "Bin/Mig_Main3D_Off.x velin=%s %s nt=%s dt=%s ot=%s vmax=4500 nodes=%s smooth=%s lpfil=%s VDer=%s gauss=%s DW=%s DWfile=%s%s.H  wfldsou=%s%s.H bfile=%s efile=%s recfile=%s%siter%s.H MWfile=%s%s.H wfmout=0 outtag=%s%siter%stmp.H >& %s"%(velfile,param,nt,dt,ot,ppn, smooth, lpfil, VDer, gauss, DW, DWfile, shot, souwfld, shot, bfile, efile, dirrr, shot, iter, MWfile, shot, dirdm, shot, iter,logfile)

if (shot > 9) and (shot < 14):
	cmd2 = 'Bin/NonStatkzkh.x < %s%siter%stmp.H outtag=%s%siter%s.H elseouttag=%s%siter%safter2.H zhout=1 kzkhout=0 Gx=%s shotnum=%s zthres=4450. UD=%s >/dev/null '%(dirdm,shot,iter,dirdm,shot,iter,dirdm,shot,iter,Gx,shot,UD)	
else:
	cmd2 = 'Bin/Testkzkh.x < %s%siter%stmp.H outtag=%s%siter%s.H elseouttag=%s%siter%safter2.H zhout=1 kzkhout=0 Gx=%s shotnum=%s UD=%s >/dev/null '%(dirdm,shot,iter,dirdm,shot,iter,dirdm,shot,iter,Gx,shot,UD)	
cmd3 ='python pycode/pyRemove.py %s%siter%stmp.H %s%siter%safter2.H'%(dirdm,shot,iter,dirdm,shot,iter)

os.system("echo '%s' >> %s"%(cmd0,cmdfile))
os.system("echo '%s' >> %s"%(cmd1,cmdfile))
os.system("echo '%s' >> %s"%(cmd2,cmdfile))
os.system("echo '%s' >> %s"%(cmd3,cmdfile))



newnode='1'
cmd1 = "pycode/pyWritePBSsep.py %s %s %s %s %s %s"%(newnode,ppn,walltime,pmem,jobname,cmdfile)
os.system(cmd1)


