#! /usr/bin/env python
#from SEP import *
import commands as cmd
import re,string
import sys, os
import os.path as path


import pyInvmodRegJoint
sbin = "./Bin"

def run(maindir,projdir,velfile,parfile,plet,K,nmz,omz,dmz,nmx,omx,dmx,nmy,omy,dmy, nhx,modax,datax, dirdata1, dirdata2, smooth,lpfil,VDer,gauss,DW, soufile1,soufile2,MWfile1,MWfile2, DWfile1,DWfile2, Rname,regParm, regax, eps,ratio):
	dirm = projdir + "/m/mDei"+plet
	dirdm = projdir + "/dm/dmDei"+plet
	dirs = projdir + "/s/sDei"+plet
	dirgg = projdir + "/gg/ggDei"+plet
	dirss = projdir + "/ss/ssDei"+plet
	dirrr = projdir + "/rr/rrDei"+plet
	dirrrm = projdir + "/rrm/rrmDei"+plet
	dirssm = projdir + "/ssm/ssmDei"+plet
	dirggm = projdir + "/ggm/ggmDei"+plet
	dmm    = projdir + '/dm/dmMDei'+plet
        sepbin = os.getenv("SEPBIN")

	cmdfile = '%s/pbs/firstPart%s.txt'%(projdir,plet)
	jobname = 'Pre%s_1'%(plet)
	logdir = '%s/pbs/logfile'%(projdir)
	os.system('rm -f %s'%(cmdfile))
	
	# Step 0: Create initial model
	cmd0='python pycode/pyRemove.py %sTotaliter1.H'%(dirm)
	cmd1 = "%s/myZero.x naxis=4 n1=%s n2=%s n3=%s n4=%s o1=0. o2=0. o3=0. o4=0. d1=1. d2=1. d3=1. d4=1. > %sTotaliter1.H"%(sbin,nmz,nmx,nmy,2*nhx+1,dirm)	
	cmd2 ="echo 'o1=%s o2=%s o3=%s o4=%s d1=%s d2=%s d3=%s d4=%s label1=z label2=x label3=y label4=hx' >> %sTotaliter1.H"%(omz,omx,omy,-nhx*dmx,dmz,dmx,dmy,dmx,dirm)
	os.system("echo '%s' >> %s"%(cmd0,cmdfile))
	os.system("echo '%s' >> %s"%(cmd1,cmdfile))
	os.system("echo '%s' >> %s"%(cmd2,cmdfile))



	# Step 1: Copy all data into /rr/ 
	if (DW):
		for i in K[:]:
		#  rrd = - Wd
			# up-going
			C1 = " %s/ApplyWgt3D.x <%s/%s%s.H Wgtfile=%s%s.H outfile=%s%stempup.H >/dev/null"%(sbin, maindir,dirdata1,i,DWfile1,i,dirrr,i)
			C2 = "%s/updateAB.x alpha=-1. cg=1 naxis=%s file1=%s%stempup.H outfile=%sup%siter1.H >/dev/null"%(sbin,datax,dirrr,i,dirrr,i)
			# down-going
			C3 = " %s/ApplyWgt3D.x <%s/%s%s.H Wgtfile=%s%s.H outfile=%s%stempdn.H >/dev/null"%(sbin, maindir,dirdata2,i,DWfile2,i,dirrr,i)
			C4 = "%s/updateAB.x alpha=-1. cg=1 naxis=%s file1=%s%stempdn.H outfile=%sdn%siter1.H >/dev/null"%(sbin,datax,dirrr,i,dirrr,i)
			C5 = 'python pycode/myRM.py %s%stempup.H %s%stempdn.H '%(dirrr,i,dirrr,i)
			os.system("echo '%s' >> %s"%(C1,cmdfile))
			os.system("echo '%s' >> %s"%(C2,cmdfile))
			os.system("echo '%s' >> %s"%(C3,cmdfile))
			os.system("echo '%s' >> %s"%(C4,cmdfile))
			os.system("echo '%s' >> %s"%(C5,cmdfile))
	else:		
		for i in K[:]:
		#  rrd = - d
			C1="python pycode/pyRemove.py %sup%siter1.H %sdn%siter1.H"%(dirrr,i,dirrr,i)
			# up-going
			C2 = "%s/updateAB.x alpha=-1. cg=1 naxis=%s file1=%s%s.H outfile=%sup%siter1.H >/dev/null"%(sbin,datax,dirdata1,i,dirrr,i)
			# down-going
			C3 = "%s/updateAB.x alpha=-1. cg=1 naxis=%s file1=%s%s.H outfile=%sdn%siter1.H >/dev/null"%(sbin,datax,dirdata2,i,dirrr,i)
			os.system("echo '%s' >> %s"%(C1,cmdfile))
			os.system("echo '%s' >> %s"%(C2,cmdfile))
			os.system("echo '%s' >> %s"%(C3,cmdfile))


	# Step 1b: rrm = 0.
	cmd1 = 'cp %sTotaliter1.H %siter1.H '%(dirm,dirrrm)
	os.system("echo '%s' >> %s"%(cmd1,cmdfile))
	
	# Submit and check above jobs
        cmd1 = "pycode/pyWritePBSsep.py %s %s %s %s %s%s %s"%(1,8,'24:00:00','2gb',jobname,i,cmdfile)
	os.system( cmd1)
	pyInvmodRegJoint.waitforjob(jobname,logdir,1800)


        #Step 2: Run adjoint to calculate dm
	pyInvmodRegJoint.Adjoint(maindir, projdir, velfile, parfile, plet,smooth, lpfil,VDer, gauss, DW, soufile1, soufile2, MWfile1, MWfile2, DWfile1, DWfile2, Rname, regParm, eps, ratio, modax,nhx, 1) 
	pyInvmodRegJoint.Add(maindir,projdir,dirdm, 1, modax, plet,dmm,dirdm)
	C1="%s/offsetmask.x < %sSUMiter%s.H vel=6. zmute=100. outfile1=%sTotaliter%s.H >/dev/null"%(sbin,dirdm,1,dirdm,1)
	C2= 'echo "label1=z label2=x label3=y label4=hx" >> %sTotaliter%s.H '%(dirdm,1)
	print C1
	print C2
	os.system(C1)
	os.system(C2)


	# Step 4: Forward gg = Fdm, ggm= eps A dm        
	pyInvmodRegJoint.Forward(maindir, projdir, velfile, parfile, plet,smooth, lpfil, VDer, gauss, DW, soufile1, soufile2, MWfile1, MWfile2, DWfile1, DWfile2, Rname, regParm, eps, ratio, modax,nhx, 1)
        	

	# Step 5: Calculate the alpha in Conjugate gradient
	alpha, beta = pyInvmodRegJoint.DPcalCG(projdir,plet,1,datax, modax, dirdm, dirggm, dirgg, dirrr, dirrrm)	
	print 'alpha, beta', alpha, beta


	#  Step 6: Update the  data residual files
	for i in K[:]:
                print 'residual update, iter 1 shot', i
                #  calculate your ss file ss=alpha*gg	
                C1 = "Bin/updateAB.x alpha=%s cg=1 naxis=%s file1=%sup%siter1.H outfile=%sup%siter2.H >/dev/null"%(alpha,datax,dirgg,i,dirss,i)
                print C1
		os.system(C1)
                C1 = "Bin/updateAB.x alpha=%s cg=1 naxis=%s file1=%sdn%siter1.H outfile=%sdn%siter2.H >/dev/null"%(alpha,datax,dirgg,i,dirss,i)
                print C1
		os.system(C1)
			             
		#  update your current residual here  rr = rr+ss
		C1 = "Bin/updateAB.x alpha=1.0 beta=1.0 naxis=%s file1=%sup%siter1.H file2=%sup%siter2.H outfile=%sup%siter2.H >/dev/null"%(datax,dirrr,i,dirss,i,dirrr,i)
		print C1
		os.system(C1)
		C1 = "Bin/updateAB.x alpha=1.0 beta=1.0 naxis=%s file1=%sdn%siter1.H file2=%sdn%siter2.H outfile=%sdn%siter2.H >/dev/null"%(datax,dirrr,i,dirss,i,dirrr,i)
		print C1
		os.system(C1)
		
	#Step 6b: Update the  model residual files
	print 'update model residual, iter 1'
	# calculate ssm = alpha*ggm 
	C1 = "Bin/updateAB.x alpha=%s cg=1 naxis=%s file1=%siter1.H outfile=%siter2.H >/dev/null"%(alpha,modax,dirggm,dirssm)
	print C1	
	os.system(C1)  
	# Calculate your new rrm = rrm + ssm
	C1 = "Bin/updateAB.x alpha=1.0 beta=1.0 naxis=%s file1=%siter1.H file2=%siter2.H outfile=%siter2.H >/dev/null"%(modax,dirrrm,dirssm,dirrrm)	
	print C1
	os.system(C1)

	
	# Step 7: Update the model files
	# Calculate your new s=alpha*dm
	print 'update model, iter 1'
	C1 = "Bin/updateAB.x alpha=%s cg=1 naxis=%s file1=%sTotaliter1.H outfile=%sTotaliter2.H >/dev/null"%(alpha,modax,dirdm,dirs)
	print C1	
	os.system(C1)  
	# Calculate your new m = m+s
	C1 = "Bin/updateAB.x alpha=1.0 beta=1.0 naxis=%s file1=%sTotaliter1.H file2=%sTotaliter2.H outfile=%sTotaliter2.H >/dev/null"%(modax,dirm,dirs,dirm)	
	print C1
	os.system(C1)
	



