#! /usr/bin/env python
#from SEP import *
import commands,re,string,sys,os
import datetime
import sys
from array import *
#import Numeric
import subprocess

## a generic PBS script set up program
#  DataCWD are specific to the script
DataCWD=os.environ["PWD"]

#input arg 1: nodes = number of node to use for this job
#input arg 2: ppn = number of processors per node (Cees cluster nodes are dual quad core)
#input arg 3: walltime = maximum time to wait for the job to finish
#input arg 4: pmem = maximum memory to allocate for the job
#input arg 5: jobname = job name (that you can reference to for checking jobs)
#input arg 6: cmdfile = the file (include path) that contains the command         
#input arg 7: (optional) : sepQ [1] use sep queue, [0] use generic queue

#output: create a pbs script, saved under the directory of cmdfile+"/pbs"
#output: possible io logfile, saved uner the directory of cmdfile+"/logfile"

# number of command line argument
n = int(len(sys.argv))-1
#print n
if (n < 6):
	print "missing arguement"
	print "pyWritePBSsep.py nodes ppn walltime pmem jobname infoDir cmdfile [sepQ]"
	sys.exit()

# obtain argument
nodes = sys.argv[1]
ppn = int(sys.argv[2])
walltime = sys.argv[3]
walltime = '24:00:00'
pmem = sys.argv[4]
jobname = sys.argv[5]
cmdfile = sys.argv[6]
if (n > 7):       
	sepQ = int( sys.argv[8])
else:
	sepQ = 1   # use sep queue by default


# scan for the string "/cmd/" in command file
# create directory for io logfile and pbs file
  # search the last occurence of '/'
  # by reverse string and then search for 1st occurence
line2 = cmdfile[::-1]
j = line2.find('/')
p0=len(cmdfile)-j-1
logdir= cmdfile[:p0]+"/logfile"
if (not os.path.exists(logdir)):
	os.system("mkdir "+logdir)
pbsdir= cmdfile[:p0]+"/pbs"
if (not os.path.exists(pbsdir)):
	os.system("mkdir "+pbsdir)

# define pbs script filename 
pbs = pbsdir+"/%s.pbs"%(jobname)


## Create queue submission file
print "constructing job script file", pbs
os.system('rm -f %s %s/%s.std %s/%s.err'%(pbs,logdir,jobname,logdir,jobname))
os.system("echo "+"'#!/bin/tcsh'"+"                                              > "+ pbs)
os.system("echo "+"                                                             >>  "+ pbs)
os.system("echo "+"'#PBS -S /bin/tcsh'"+"                                       >>  "+ pbs)
cmd1 = 'echo "#PBS -l nodes=%s:ppn=%s" >> %s'%(nodes,ppn,pbs)
os.system(cmd1)
#cmd1 = 'echo "#PBS -l pmem=%s" >> %s'%(pmem,pbs)
#os.system(cmd1)
cmd1 = 'echo "#PBS -l walltime=%s"  >> %s'%(walltime,pbs)
os.system(cmd1)
os.system("echo "+"'#PBS -j oe               '"+"                               >>  "+ pbs)

# Use default que
#if (sepQ == 1):
#	os.system("echo "+"'#PBS -q sep            '"+"                               >>  "+ pbs)
#	print "using SEP queue"
#else:
#	os.system("echo "+"'#PBS -q default          '"+"                             >>  "+ pbs)
#	print "using default queue"

os.system("echo "+"'#PBS -q sep          '"+"                             >>  "+ pbs)

cmd1 = 'echo "#PBS -o %s/%s.std"  >> %s'%(logdir,jobname,pbs)
os.system(cmd1)
cmd1 = 'echo "#PBS -e %s/%s.err"  >> %s'%(logdir,jobname,pbs)
os.system(cmd1)
cmd1 = 'echo "#PBS -N %s" >> %s'%(jobname,pbs)
os.system(cmd1)

os.system("echo " + "'setenv PBS_O_WORKDIR '"+DataCWD+"                             >>  "+ pbs)
os.system("echo " + "'cd $PBS_O_WORKDIR'"+"                                     >>  "+ pbs)
os.system("echo " + "'setenv OMP_NUM_THREADS 8 '"+"                             >>  "+ pbs)
os.system("echo " + "'setenv PSC_OMP_AFFINITY TRUE '"+"                         >>  "+ pbs)

# append command to run the job
cmd1 = "cat %s >> %s"%(cmdfile,pbs)
os.system(cmd1)
os.system("chmod 744                                                                "+ pbs)
	


# submit the job to the cluster
os.system("qsub %s"%(pbs))
	

