#! /usr/bin/env python
#from SEP import *
import commands,re,string,sys,os
import datetime
import sys
import subprocess
sys.path.append('./pycode')
from pyLoc import *

outdir = sys.argv[1]
d1    = sys.argv[2]
iter  = int(sys.argv[3])
naxis = sys.argv[4]
plet = sys.argv[5]
dmm   = sys.argv[6]

# This script sum all the rtm files 
sbin = "bin"

nodes = 1   # number of nodes for each job
ppn=16     # number of processor per node
walltime='1:00:00'  # max time to wait for the job to finish
pmem = '2gb'  # max memory to allocate for the job
jobname = 'Add%s%s'%(plet,iter) # Job name 

d1BK = d1+'BK'
d1SUP= d1+'SUP'

if (os.path.isdir('%s/pbs'%(outdir)) != 1):
	os.system('mkdir %s/pbs'%(outdir))
if (os.path.isdir('%s/logfile'%(outdir)) != 1):
	os.system('mkdir %s/logfile'%(outdir))
cmdfile = "%s/pbs/PBS%s.txt"%(outdir,plet)
logfile = "%s/pbs/logfile/rtmsum%s.txt"%(outdir,plet)
os.system("rm -f %s %s"%(cmdfile,logfile))

print 'cmdfile', cmdfile
print 'logfile', logfile

# Calculate number of blocks
nblock = len(K)/10           # sum 10 shots at a Time
nLB = len(K) - nblock*10
if (nLB == 0):        	
	nLB = 10
else:
	nblock = len(K)/10+1
        		
# Calculating the first nblock-1 blocks, 10 files per block
for block in range(1,nblock):
	print 'summing Block #', block 
	k = (block-1)*10
	cmd1 = "%s/SUMMING.x nfile=10 naxis=%s outfile=%s%s.H "%(sbin,naxis,d1BK,block)
	for i in range(1,10+1):
		cmd1 = cmd1+ "file%s=%s%siter%s.H "%(i,d1,K[k+i-1],iter)
	cmd1 = cmd1+' >/dev/null'	
	os.system("echo '%s' >> %s"%(cmd1,cmdfile))


# Calculate the last block, contains nLB files
print 'Block #', nblock
block = nblock	
cmd1 = "%s/SUMMING.x nfile=%s naxis=%s outfile=%s%s.H "%(sbin,nLB,naxis,d1BK,block)
for i in range(1,nLB+1):
	cmd1=cmd1+' file%s=%s%siter%s.H '%(i,d1,K[i-1+len(K)-nLB],iter)    	
cmd1= cmd1+' >/dev/null'
os.system("echo '%s' >> %s"%(cmd1,cmdfile))
    		
                 	  	  	  	
# Sum all the block to form a big model, assume nblock <= 30 
if (nblock < 11): 
	cmd1 = "%s/SUMMING.x nfile=%s naxis=%s outfile=%s1.H "%(sbin,nblock, naxis,d1SUP)
	erase = "python pycode/pyRemove.py "
	for i in range(1, nblock+1):
		cmd1 = cmd1 + ' file%s=%s%s.H'%(i,d1BK,i)
		erase = erase + ' %s/rtm%s_block%s.H'%(outdir,plet,i)
	cmd1 = cmd1 + ' >/dev/null' 
	# sum the superblocks together
	cmd2 = "%s/SUMMING.x nfile=2 naxis=%s file1=%s1.H file2=%siter%s.H outfile=%sTotaliter%s.H "%(sbin, naxis, d1SUP,dmm,iter,d1,iter)
	erase = erase + ' %s1.H '%(d1SUP)
	os.system("echo '%s' >> %s"%(cmd1,cmdfile))
	os.system("echo '%s' >> %s"%(cmd2,cmdfile))
	os.system("echo '%s' >> %s"%(erase,cmdfile))
elif ( (nblock > 10) & (nblock < 21)):
	cmd1 = "%s/SUMMING.x nfile=%s naxis=%s outfile=%s1.H "%(sbin,10, naxis, d1SUP)
	cmd2 = "%s/SUMMING.x nfile=%s naxis=%s outfile=%s2.H "%(sbin,nblock-10, naxis, d1SUP)
	erase = "python pycode/pyRemove.py "
	for block in range(1, 10+1):
		cmd1 = cmd1 + ' file%s=%s%s.H'%(block,d1BK,block)
		erase = erase + ' %s%s.H'%(d1BK,block)
	for block in range(1, nblock-10+1):
		cmd2 = cmd2 + ' file%s=%s%s.H'%(block,d1BK,block+10)
		erase = erase + ' %s%s.H'%(d1BK,block)
	cmd1 = cmd1 + ' >/dev/null' 
	cmd2 = cmd2 + ' >/dev/null' 
	# sum the superblocks together
	cmd3 = "%s/SUMMING.x nfile=3 naxis=%s file1=%s1.H file2=%s2.H file3=%siter%s.H outfile=%sTotaliter%s.H "%(sbin, naxis, d1SUP,d1SUP,dmm,iter,d1,iter)
	erase = erase + ' %s1.H %s2.H'%(d1SUP,d1SUP)
	os.system("echo '%s' >> %s"%(cmd1,cmdfile))
	os.system("echo '%s' >> %s"%(cmd2,cmdfile))
	os.system("echo '%s' >> %s"%(cmd3,cmdfile))
	os.system("echo '%s' >> %s"%(erase,cmdfile))
elif ( (nblock > 20) & (nblock < 31)):
	cmd1 = "%s/SUMMING.x nfile=%s naxis=%s outfile=%s1.H "%(sbin,10, naxis, d1SUP)
	cmd2 = "%s/SUMMING.x nfile=%s naxis=%s outfile=%s2.H "%(sbin,10, naxis, d1SUP)
	cmd3 = "%s/SUMMING.x nfile=%s naxis=%s outfile=%s3.H "%(sbin,nblock-20, naxis, d1SUP)
	erase = "python pycode/pyRemove.py "
	for i in range(1, 10+1):
		cmd1 = cmd1 + ' file%s=%s%s.H'%(i,d1BK,i)
		cmd2 = cmd2 + ' file%s=%s%s.H'%(i,d1BK,i+10)
		erase = erase + ' %s%s.H %s%s.H'%(d1BK,i,d1BK,i+10)
	for i in range(1, nblock-20+1):
		cmd3 = cmd3 + ' file%s=%s%s.H'%(i,d1BK,i+20)
		erase = erase + ' %s%s.H'%(d1BK,i)
	cmd1 = cmd1 + ' >/dev/null' 
	cmd2 = cmd2 + ' >/dev/null' 
	cmd3 = cmd3 + ' >/dev/null' 
	# sum the superblocks together
	cmd4 = "%s/SUMMING.x nfile=4 naxis=%s file1=%s1.H file2=%s2.H file3=%s3.H file4=%siter%s.H outfile=%sTotaliter%s.H >/dev/null "%(sbin, naxis, d1SUP,d1SUP,d1SUP,dmm,iter,d1,iter)
	erase = erase + ' %s1.H %s2.H %s3.H'%(d1SUP,d1SUP,d1SUP)
	os.system("echo '%s' >> %s"%(cmd1,cmdfile))
	os.system("echo '%s' >> %s"%(cmd2,cmdfile))
	os.system("echo '%s' >> %s"%(cmd3,cmdfile))
	os.system("echo '%s' >> %s"%(cmd4,cmdfile))
	os.system("echo '%s' >> %s"%(erase,cmdfile))			



# Submit job to the cluster
cmd1 = "pycode/pyWritePBS.py %s %s %s %s %s %s 0"%(nodes,ppn,walltime,pmem,jobname,cmdfile)
print cmd1
os.system( cmd1)


	
