#! /usr/bin/env python
#from SEP import *
import commands as cmd
import re,string
import sys, os
import os.path as path


from pyBath import *


import pyInvmodRegOneDir
import pyfirstiterRegOneDir

# ----------------------------------------------------------------
# ----- Project specific Definition -------- *** Need Changing ***
# ----------------------------------------------------------------

# Please make sure pyAdjoint and pyForward include the proper pyLOC.py file that contains the location of the nodes
# L = [[0],['A',GxA,GyA,GzA],['B',GxB,GyB,GzB],['C',GxC,GyC,GzC], ...]

sbin = "./Bin/"
maindir = "." # where souwfld, syndat, Input, bin 
projdir = maindir + "/LSM/Hb"            # Project directory, where all intermediate output stored
plet = 'Hb'                                  # Project letter (to avoid overwrite in scr)

# ---- File names and project directories ----------------
velfile= 'Input/velDeimos3D.H'        # vel file (located at projdir/Input/.)
parfile = 'PMigSddA.par'              # Adjoint param file (located at projdir/Par/.)
dirdata = 'fiedat/D/fdDeiD'           # up-going
souwfld =  'souwfld/B/swDeiB'         # up-going
DWfile  = 'DWfile/H/DWDeiHb'       # Data weighting files - up
MWfile  =  'MWfile/E/mwDeiE'         # Model weighting files
UD = 1                                # 1=up, 2=dn
# ---------- Preconditioning and Regularization -----------------------
Rname = 'DSO3d.x'                           # Program name for regularization operation
eps   = 1.00                              # Epsilon is 20% between ratio of initial ggmDggm and ggDgg
ratio = 0.                                 # Initialization for ggdDggd/ggmDggm
smooth = 0                                    
lpfil  = 0
gauss  = 0
VDer   = 1
DW     = 1                                 # Data space weighting

# ---- Conjugate Gradient or Direction ----------------------
CD    = 0                                  # [1] Conjugate Direction [0] Conjudate Gradient

# ---- Image space parameters ---------------
modax = 4                                  # number of axis in image file
nmz = 287                                  # nz 
omz = 850.                                 # oz
dmz = 25.                                  # dz
nmx = 420                                  # nx
omx = 50000.                               # ox
dmx = 25.                                  # dx
nmy = 28                                   # ny
omy = 34450.                               # oy
dmy = 25.                                  # dy
nhx = 30

# --- Data space parameters ----------------
datax = 3                               # number of axis in data space

# ----- Iteration loop ----------------------
biter = 1	                             # Beginning iteration
eiter = 25                             # End iteration




# ----------------------------------------------------------------
# ------- End of Definition --------------------------------------
# ----------------------------------------------------------------

dirm  = projdir+'/m/mDei'+plet
dirs  = projdir+'/s/sDei'+plet
dirdm = projdir+'/dm/dmDei'+plet
dirgg = projdir+'/gg/ggDei'+plet
dirss = projdir+'/ss/ssDei'+plet
dirrr = projdir+'/rr/rrDei'+plet

dirggm = projdir+'/ggm/ggmDei'+plet
dirssm = projdir+'/ssm/ssmDei'+plet
dirrrm = projdir+'/rrm/rrmDei'+plet
dmm    = projdir + '/dm/dmMDei'+plet

os.system("cd ..")
compie=1
if (compie == 1):
	os.system("make Bin/modcgstep.x")
	os.system("make Bin/Mig_Main3D.x")
	os.system("make Bin/Forward3D.x")
	os.system("make Bin/updateAB.x")
	os.system("make Bin/Solver_ops.x")
	os.system("make Bin/ApplyWgt3D.x")
	os.system("make Bin/SUMMING.x")
	os.system("make Bin/ParabolicTauPfilter.x")

	cmd1= 'make Bin/%s'%(Rname)
	os.system(cmd1)

refiter=1


if (biter == 1):
	pyfirstiterRegOneDir.run(maindir,projdir,velfile,parfile, plet,K,UD,nmz,omz,dmz,nmx,omx,dmx,nmy,omy,dmy,nhx,modax,datax,dirdata,smooth,lpfil,VDer, gauss, DW, souwfld, MWfile, DWfile, Rname,eps,ratio)
	biter = biter+1


# At this point, iter 1 is already finished, so calculate ratio
#ratio = pyInvmodRegOneDir.Ratio(maindir,projdir,plet,K,Rname,modax,datax,1)
#print 'ggmDggm vs ggdDggd ratio', ratio

for iter in range(biter,eiter+1):


	print 'Running iteration#', iter
        
	# Step 2: Loop shots  dm = F'Rd  + eps A' Rm
	if (iter != -1*biter):
		if ((CD == 0) and (iter%5 == 0)):  # Remove static residual every 5 iterations
			refiter = iter-4
			#pyInvmodRegOneDir.EraseStatic(iter,refiter,datax,dirrr)
			pyInvmodRegOneDir.EraseTop(projdir,plet,iter,datax,dirrr)
		pyInvmodRegOneDir.Adjoint(maindir, projdir, velfile, parfile, plet, UD, smooth, lpfil,VDer, gauss, DW, souwfld,MWfile, DWfile, Rname, eps, ratio, modax, nhx, iter)
		pyInvmodRegOneDir.Add(maindir,projdir,dirdm, iter, modax, plet,dmm,dirdm)
		C1="%s/offsetmask.x < %sSUMiter%s.H vel=6. zmute=100. outfile1=%sTotaliter%s.H >/dev/null"%(sbin,dirdm,iter,dirdm,iter)
		C2= 'echo "label1=z label2=x label3=y label4=hx" >> %sTotaliter%s.H '%(dirdm,iter)
		print C1
		print C2
		os.system(C1)
		os.system(C2)


	# Step 4: Loop shots  gg = Fdm and ggm= eps A dm        
	if (iter != -1*biter):
		pyInvmodRegOneDir.Forward(maindir, projdir, velfile, parfile, plet, UD, smooth, lpfil,VDer, gauss, DW, souwfld, MWfile, DWfile, Rname, eps, ratio, modax, nhx, iter)
			                
        
        # Step 5: Calculate the alpha and beta in conjugate direction
	# Step 6: Update the model and data residual files
	if (CD == 1):
	        alpha, beta = pyInvmodRegOneDir.DPcalCD(projdir, plet,iter,datax,modax, dirdm, dirggm, dirgg, dirrr, dirrrm, dirss, dirssm)
		pyInvmodRegOneDir.CDmodelupdate(alpha,beta,projdir,plet,iter,datax,modax,dirrr,dirgg,dirss,dirrrm,dirggm,dirssm,dirdm,dirm,dirs)
	else:
		alpha, beta = pyInvmodRegOneDir.DPcalCG(projdir,plet,iter,datax, modax, dirdm, dirggm, dirgg, dirrr, dirrrm)	
		pyInvmodRegOneDir.CGmodelupdate(alpha,projdir,plet,iter,datax,modax,dirrr,dirgg,dirss,dirrrm,dirggm,dirssm,dirdm,dirm,dirs)

	print 'alpha, beta', alpha, beta

        # Step 9, remove files
#	if (( int(iter)% 3 !=0) and (int(iter) > 3) ):
#		print 'remove files', iter, int(iter)-2
#		pyInvmodRegOneDir.removefiles(projdir,int(iter)-2,plet)

# Calculate final residuals and save to report
iiter = iter+1
resid = pyInvmodRegOneDir.ResidCal(projdir, plet,K,iiter,datax,dirrr)
file = open(projdir+'/Reportsave.txt', 'a')              # save to report
cmd1 = " %s na na %s \n"%(iter, resid)
file.writelines(cmd1);
file.close()
