#! /usr/bin/env python
#from SEP import *
import commands as cmd
import re,string
import sys, os
import os.path as path


from pyBath import *


import pyInvmodRegOneDir
import pyfirstiterRegOneDir

# ----------------------------------------------------------------
# ----- Project specific Definition -------- *** Need Changing ***
# ----------------------------------------------------------------

# Please make sure pyAdjoint and pyForward include the proper pyLOC.py file that contains the location of the nodes
# L = [[0],['A',GxA,GyA,GzA],['B',GxB,GyB,GzB],['C',GxC,GyC,GzC], ...]

sbin = "./Bin/"
maindir = "." # where souwfld, syndat, Input, bin 
projdir = maindir + "/LSM/I"            # Project directory, where all intermediate output stored
plet = 'I'                                  # Project letter (to avoid overwrite in scr)

# ---- File names and project directories ----------------
velfile= 'Input/velDeimos3D.H'        # vel file (located at projdir/Input/.)
parfile = 'PMigSddA.par'              # Adjoint param file (located at projdir/Par/.)
dirdata = 'fiedat/A/fdDeiA'           # up-going
souwfld =  'souwfld/A/swDeiA'         # up-going
DWfile  = 'DWfile/A/DeiMskA'          # Data weighting files
MWfile  =  'MWfile/E/mwDeiE'         # Model weighting files
UD = 2                                # 1=up, 2=dn
# ---------- Preconditioning and Regularization -----------------------
Rname = 'DSO3d.x'                           # Program name for regularization operation
eps   = 1.00                              # Epsilon is 20% between ratio of initial ggmDggm and ggDgg
ratio = 0.                                 # Initialization for ggdDggd/ggmDggm
smooth = 0                                    
lpfil  = 0
gauss  = 0
VDer   = 1
DW     = 1                                 # Data space weighting

# ---- Image space parameters ---------------
modax = 4                                  # number of axis in image file
nmz = 287                                  # nz 
omz = 850.                                 # oz
dmz = 25.                                  # dz
nmx = 420                                  # nx
omx = 50000.                               # ox
dmx = 25.                                  # dx
nmy = 28                                   # ny
omy = 34450.                               # oy
dmy = 25.                                  # dy
nhx = 30

# --- Data space parameters ----------------
datax = 3                               # number of axis in data space

# ----- Iteration loop ----------------------
biter = 1	                             # Beginning iteration
eiter = 25                             # End iteration




# ----------------------------------------------------------------
# ------- End of Definition --------------------------------------
# ----------------------------------------------------------------

dirm  = projdir+'/m/mDei'+plet
dirs  = projdir+'/s/sDei'+plet
dirdm = projdir+'/dm/dmDei'+plet
dirgg = projdir+'/gg/ggDei'+plet
dirss = projdir+'/ss/ssDei'+plet
dirrr = projdir+'/rr/rrDei'+plet

dirggm = projdir+'/ggm/ggmDei'+plet
dirssm = projdir+'/ssm/ssmDei'+plet
dirrrm = projdir+'/rrm/rrmDei'+plet
dmm    = projdir + '/dm/dmMDei'+plet

os.system("cd ..")
compie=1
if (compie == 1):
	os.system("make Bin/modcgstep.x")
	os.system("make Bin/Mig_Main3D.x")
	os.system("make Bin/Forward3D.x")
	os.system("make Bin/updateAB.x")
	os.system("make Bin/Solver_ops.x")
	os.system("make Bin/ApplyWgt3D.x")
	os.system("make Bin/SUMMING.x")
	os.system("make Bin/ParabolicTauPfilter.x")

	cmd1= 'make Bin/%s'%(Rname)
	os.system(cmd1)


if (biter == 1):
	pyfirstiterRegOneDir.run(maindir,projdir,velfile,parfile, plet,K,UD,nmz,omz,dmz,nmx,omx,dmx,nmy,omy,dmy,nhx,modax,datax,dirdata,smooth,lpfil,VDer, gauss, DW, souwfld, MWfile, DWfile, Rname,eps,ratio)
	biter = biter+1


# At this point, iter 1 is already finished, so calculate ratio
ratio = pyInvmodRegOneDir.Ratio(maindir,projdir,plet,K,Rname,modax,datax,1)
print 'ggmDggm vs ggdDggd ratio', ratio

for iter in range(biter,eiter+1):


	print 'Running iteration#', iter
	
	# Step 2: Loop shots  dm = F'Rd  + eps A' Rm
	if (iter != -1*biter):
		pyInvmodRegOneDir.Adjoint(maindir, projdir, velfile, parfile, plet, UD, smooth, lpfil,VDer, gauss, DW, souwfld,MWfile, DWfile, Rname, eps, ratio, modax, nhx, iter)
		pyInvmodRegOneDir.Add(maindir,projdir,dirdm, iter, modax, plet,dmm,dirdm)
       # Step 3: Split the updates into 2 files
		C1="%s/offsetmask.x < %sSUMiter%s.H vel=6. zmute=100. outfile1=%sTotaliter%s.H >/dev/null"%(sbin,dirdm,iter,dirdm,iter)
		C2= 'echo "label1=z label2=x label3=y label4=hx" >> %sTotaliter%s.H '%(dirdm,iter)
		print C1
		print C2
		os.system(C1)
		os.system(C2)


	# Step 4: Loop shots  gg = Fdm and ggm= eps A dm        
	if (iter != -1*biter):
		pyInvmodRegOneDir.Forward(maindir, projdir, velfile, parfile, plet, UD, smooth, lpfil,VDer, gauss, DW, souwfld, MWfile, DWfile, Rname, eps, ratio, modax, nhx, iter)
			                
        
        # Step 5: Calculate the alpha and beta in conjugate direction
	alpha, beta = pyInvmodRegOneDir.DPcalCG(projdir,plet,iter,datax, modax, dirdm, dirggm, dirgg, dirrr, dirrrm)	
	print 'alpha, beta', alpha, beta
#        alpha, beta = pyInvmodRegOneDir.DPcalCD(projdir, plet,iter,datax,modax, dirdm, dirggm, dirgg, dirrr, dirrrm, dirss, dirssm)
	

	# Step 6a: Update the residual files
	print 'update data residual, iter', iter
	cmdfile = '%s/pbs/updateiter%s.txt'%(projdir,iter)
	logdir = '%s/pbs/logfile'%(projdir)
	jobnameMain = 'UpD%s_%s'%(plet,iter)
        os.system('rm -f %s'%(cmdfile))
	for i in K[:]:
        	print 'residual update, iter', iter, 'shot', i
                #  calculate your ss file ss=alpha*rr+beta*ss	
        	C1 = "%s/updateAB.x alpha=%s beta=%s naxis=%s file1=%s%siter%s.H file2=%s%siter%s.H outfile=%s%siter%s.H >/dev/null"%(sbin,alpha,beta,datax,dirgg,i,iter,dirss,i,iter,dirss,i,iter+1)
		os.system("echo '%s' >> %s"%(C1,cmdfile))
			             
		#  update your current residual here  rr=rr+ss
		C1 = "%s/updateAB.x alpha=1.0 beta=1.0 naxis=%s file1=%s%siter%s.H file2=%s%siter%s.H outfile=%s%siter%s.H >/dev/null"%(sbin,datax,dirrr,i,iter,dirss,i,iter+1,dirrr,i,iter+1)	
		os.system("echo '%s' >> %s"%(C1,cmdfile))

	# Step 6b: Update the  model residual files
	print 'update model residual, iter', iter
	# calculate ssm = alpha*ggm 
	C1 = "%s/updateAB.x alpha=%s cg=1 naxis=%s file1=%siter%s.H outfile=%siter%s.H >/dev/null"%(sbin,alpha,modax,dirggm,iter,dirssm,iter+1)
	os.system("echo '%s' >> %s"%(C1,cmdfile))




	# Step 7a: Calculate your new rrm = rrm + ssm
	C1 = "%s/updateAB.x alpha=1.0 beta=1.0 naxis=%s file1=%siter%s.H file2=%siter%s.H outfile=%siter%s.H >/dev/null"%(sbin,modax,dirrrm,iter,dirssm,iter+1,dirrrm,iter+1)	
	os.system("echo '%s' >> %s"%(C1,cmdfile))

	# Step 7: Update the model files
	# Calculate your new dm s=alpha*dm+beta*s
	print 'model update, iter', iter
	C1 = "%s/updateAB.x alpha=%s beta=%s naxis=%s file1=%sTotaliter%s.H file2=%sTotaliter%s.H outfile=%sTotaliter%s.H >/dev/null"%(sbin,alpha,beta,modax,dirdm,iter,dirs,iter,dirs,iter+1)	
	os.system("echo '%s' >> %s"%(C1,cmdfile))


	# Step 8: Calculate your new m
	C1 = "%s/updateAB.x alpha=1.0 beta=1.0 naxis=%s file1=%sTotaliter%s.H file2=%sTotaliter%s.H outfile=%sTotaliter%s.H >/dev/null"%(sbin,modax,dirm,iter,dirs,iter+1,dirm,iter+1)	
	os.system("echo '%s' >> %s"%(C1,cmdfile))


	# Submit job and wait until it is done
	cmd1 = "pycode/pyWritePBSsep.py %s %s %s %s %s%s %s"%(1,8,'24:00:00','2gb',jobnameMain,i,cmdfile)
	os.system( cmd1)
	pyInvmodRegOneDir.waitforjob(jobnameMain,logdir,1800)       

        # Step 9, remove files
	if (( int(iter)% 3 !=0) and (int(iter) > 3) ):
		print 'remove files', iter, int(iter)-2
		pyInvmodRegOneDir.removefiles(maindir,int(iter)-2,plet)

# Calculate final residuals and save to report
iiter = iter+1
resid = pyInvmodRegOneDir.ResidCal(projdir, plet,K,iiter,datax,dirrr)
file = open(projdir+'/Reportsave.txt', 'a')              # save to report
cmd1 = " %s na na %s \n"%(iter, resid)
file.writelines(cmd1);
file.close()
